<?php
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: dosub.php                                                 #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

error_reporting(0);  
//error_reporting(E_ALL);

include_once '../config.php';
include_once '../themes/'.$themeName.'/options.php';
include '../functions.php';

session_name($sessionIdentifier);
session_start();

$imggallerypath='../galleries/';
$currentURL=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];

$includeFlag='1'; //only way for our included files to know their included.

$username=$_SESSION['s_userName'];

$action=$_GET['action'];

if(isset($_GET['vm'])){
        $vm=$_GET['vm'];
}else{
        $vm='false';
}

//you must be a valid user to do this
if(isset($_SESSION['s_userName'])) {

	switch($action){
                case 'confirmdeleteimage':

                        $galleryname='';
                        if(isset($_GET['galleryname'])){
                                $galleryname=$_GET['galleryname'];
                        }else if(isset($_POST['galleryname'])){
                                $galleryname=$_POST['galleryname'];
                        }
			
			if(!can_edit($galleryname, $_SESSION['s_userName'])){
				if($kickmeto!=''){
                            		header("Location: http://$kickmeto");
					break;
                        	}else{
                            		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
					break;
                        	}
			}

                        $filetodelete='';
                        if(isset($_GET['filetodelete'])){
                                $filetodelete=$_GET['filetodelete'];
                        }else if(isset($_POST['filetodelete'])){
                                $filetodelete=$_POST['filetodelete'];
                        }
                        $filetodelete=html_entity_decode($filetodelete, ENT_QUOTES);

                        $kickmeto='';
                        if(isset($_POST['kickmeto'])){
                                $kickmeto=$_POST['kickmeto'];
                        }else if(isset($_GET['kickmeto'])){
                                $kickmeto=$_GET['kickmeto'];
                        }

			//Security check. make sure this is a supported file type.
			if(!is_image($filetodelete) && !is_movie($filetodelete)){
				log_action("DELETE_FILE", "FAILED", $galleryname, "ATTEMPT TO DELETE UNSUPPORTED FILE - {$filetodelete}");
				die("NO HACK PROTECTION ACTIVATED");
				exit(0);
			}

                        $completepath=$imggallerypath.$galleryname."/".$filetodelete;
			$completepathconfig=$imggallerypath.$galleryname."/".$filetodelete.".php";
			$completepaththm=$imggallerypath.$galleryname."/thm_".$filetodelete;
			$completepathlowres=$imggallerypath.$galleryname."/lowres_".$filetodelete;

			@unlink($completepath);
			@unlink($completepathconfig);
			@unlink($completepaththm);
			@unlink($completepathlowres);

			log_action("DELETE_FILE", "SUCCESS", $galleryname, "DELETED FILE - {$filetodelete}");

			if($vm!='ajax'){
				if($kickmeto!=''){
				    header("Location: http://$kickmeto");
				}else{
				    header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?error=DELSuccess");
				}
                        }else{
                                echo "<script type='text/javascript'>
					    parent.$.fn.colorbox.close();
				      </script>";
                        }
			break;

                case 'confirmdeletegallery':

                        $galleryname='';
                        if(isset($_POST['galleryname'])){
                            $galleryname=$_POST['galleryname'];
                        }else if(isset($_GET['galleryname'])){ 
                            $galleryname=$_GET['galleryname'];
                        }

			if(!can_edit($galleryname, $_SESSION['s_userName'])){
                                if($kickmeto!=''){
                                        header("Location: http://$kickmeto");
                                        break;
                                }else{
                                        header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
                                        break;
                                }
                        }

                        $completepath=$imggallerypath.$galleryname."/";

                        //RETRIEVE GALLERY FILE LISTING
                        $g_Listing2 = dir($imggallerypath.'/'.$galleryname);
                                while($entry = $g_Listing2->read()) {
                                        if( ($entry!="." && $entry!="..") ){
                                                @unlink($completepath.$entry);
                                        }
                                }
                        $g_Listing2->close();

                        @rmdir($completepath);

			log_action("DELETE_GALLERY", "SUCCESS", $galleryname, "DELETED GALLERY - {$galleryname}");

			if($vm!='ajax'){
	                        header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?error=DELGSuccess");
                        }else{
                                echo "<script type='text/javascript'>
                                          //setTimeout('parent.$.fn.colorbox.close();', 1250);  
					  parent.$.fn.colorbox.close();
                                      </script>";
                        }

                        break;

                 case 'saveimagecaption':

                        $galleryname='';
                        if(isset($_GET['galleryname'])){
                                $galleryname=$_GET['galleryname'];
                        }else if(isset($_POST['galleryname'])){
                                $galleryname=$_POST['galleryname'];
                        }
			
                        if(!can_edit($galleryname, $_SESSION['s_userName'])){
                                if($kickmeto!=''){
                                        header("Location: http://$kickmeto");
                                        break;
                                }else{
                                        header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
                                        break;
                                }
                        }           
                        
                        $filetoset='';
                        if(isset($_GET['filetoset'])){
                                $filetoset=$_GET['filetoset'];
                        }else if(isset($_POST['filetoset'])){  
                                $filetoset=$_POST['filetoset'];
                        }       
                        $filetoset=html_entity_decode($filetoset, ENT_QUOTES);

			$caption='';
                        if(isset($_GET['caption'])){
                                $caption=htmlentities(trim(stripslashes($_GET['caption'])), ENT_QUOTES);
                        }else if(isset($_POST['caption'])){ 
                                $caption=htmlentities(trim(stripslashes($_POST['caption'])), ENT_QUOTES);
                        }

                        $kickmeto='';
                        if(isset($_POST['kickmeto'])){
                                $kickmeto=$_POST['kickmeto'];
                        }else if(isset($_GET['kickmeto'])){ 
                                $kickmeto=$_GET['kickmeto'];
                        }

			//Security check. make sure this is a supported file type.
                        if(!is_image($filetoset) && !is_movie($filetoset)){
                                log_action("SET_CAPTION", "FAILED", $galleryname, "ATTEMPT TOSET CAPTION ON UNSUPPORTED FILE - {$filetoset}");
                                die("NO HACK PROTECTION ACTIVATED");
                                exit(0);
                        }
                         
                        $filename=$imggallerypath.$galleryname."/".$filetoset.".php";
                         
                        //we made it here so its time to modify - dont forget the lock!
                        $pf=fopen($filename, 'w+');
                         
                        flock($pf, LOCK_EX);   
                        fwrite($pf, "<?php\n");
                        fwrite($pf, "\$imageDetails=array(\"{$caption}\");\n");
                        fwrite($pf, "?>\n");
                        //relinquish the lock
                        flock($pf, LOCK_UN);
                        fclose($pf);

			log_action("SET_CAPTION", "SUCCESS", $galleryname, "SAVED IMAGE CAPTION - {$filetoset} - $caption");

			if($vm!='ajax'){
                               if($kickmeto!=''){
                                   header("Location: http://$kickmeto");
                               }else{
                                   header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?error=THMSuccess");
                               }
                        }else{
                               echo "<script type='text/javascript'>
                                       parent.$.fn.colorbox.close();
                               </script>";
                        }       
                        
                        break;

                case 'confirmsetthumb':

                        $galleryname='';
                        if(isset($_GET['galleryname'])){
                                $galleryname=$_GET['galleryname'];
                        }else if(isset($_POST['galleryname'])){
                                $galleryname=$_POST['galleryname'];
                        }

			if(!can_edit($galleryname, $_SESSION['s_userName'])){
                                if($kickmeto!=''){
                                        header("Location: http://$kickmeto");
                                        break;
                                }else{
                                        header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
                                        break;
                                }
                        }
                        
			if(is_movie($filetoset)){
                                if($vm!='ajax'){
                                        if($kickmeto!=''){
                                                header("Location: http://$kickmeto");
                                        }else{
                                                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=vg&g=$galleryname");
                                        }
                                }else{
                                        echo "<script type='text/javascript'>
                                                    parent.$.fn.colorbox.close();
                                              </script>";
                                }
                        }
     
                        $filetoset='';
                        if(isset($_GET['filetoset'])){
                                $filetoset=$_GET['filetoset'];
                        }else if(isset($_POST['filetoset'])){
                                $filetoset=$_POST['filetoset'];
                        }
                        $filetoset=html_entity_decode($filetoset, ENT_QUOTES);

                        $kickmeto='';
                        if(isset($_POST['kickmeto'])){
                                $kickmeto=$_POST['kickmeto'];
                        }else if(isset($_GET['kickmeto'])){
                                $kickmeto=$_GET['kickmeto'];
                        }

			//Security check. make sure this is a supported file type.
                        if(!is_image($filetoset) && !is_movie($filetoset)){
                                log_action("SET_THUMBNAIL", "FAILED", $galleryname, "ATTEMPT TO SET GALLERY THUMBNAIL IMAGE TO UNSUPPORTED FILE - {$filetoset}");
                                die("NO HACK PROTECTION ACTIVATED");
                                exit(0);            
                        }

			$filename=$imggallerypath.$galleryname."/thm.php";

			//we made it here so its time to modify - dont forget the lock!
			$pf=fopen($filename, 'w+');
			$filecontents = "thm_".trim($filetoset);

			flock($pf, LOCK_EX);
			fwrite($pf, "<?php\n");
			fwrite($pf, "\$galleryThumbnail=\"{$filecontents}\";\n");
			fwrite($pf, "?>\n");
			//relinquish the lock
			flock($pf, LOCK_UN);
			fclose($pf);

			log_action("SET_THUMBNAIL", "SUCCESS", $galleryname, "SET GALLERY THUMBNAIL IMAGE - {$filetoset}");

			if($vm!='ajax'){
	                        if($kickmeto!=''){
	                            header("Location: http://$kickmeto");
	                        }else{
	                            header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?error=THMSuccess");
				}
			}else{
				echo "<script type='text/javascript'>
					parent.$.fn.colorbox.close(); 
				</script>";
			}

                        break;

                case 'confirmgallerydetails':
                        $galleryname=$_POST['galleryname'];
                        $gallerytitle=htmlentities(trim(stripslashes($_POST['gallerytitle'])), ENT_QUOTES);
                        $gallerydesc=htmlentities(trim(stripslashes($_POST['gallerydesc'])), ENT_QUOTES);
                        $date=htmlentities($_POST['gallerydate'], ENT_QUOTES);
			$downloadLink=htmlentities(trim($_POST['downloadLink']), ENT_QUOTES);
			$gallerycopyright=htmlentities(trim(stripslashes($_POST['gallerycopyright'])), ENT_QUOTES);
			$concealPath=htmlentities(trim($_POST['concealPath']), ENT_QUOTES);
			$sortOrder=$_POST['galleryViewSortOrder'];

                        //lets avoid trouble and stop these errors in their tracks
                        if((!$galleryname)||(!$gallerytitle)||(!$gallerydesc)){
                                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?action=editgallerydetails&galleryname={$galleryname}&error=GCblank&vm={$vm}");
                                break;
                        }
                        
                        $absolute_path = $imggallerypath.$galleryname;

                        if(!file_exists($absolute_path)){
				$date=currentDate()."@".time();
				$parsedusername=strtolower(str_replace(" ", "", $username));

                //create beautifully simple gallery directory names.
                if($galleryname=="NEW"){
                    $gallery_index=0;
                    while(file_exists($imggallerypath.$parsedusername."_".$gallery_index)){
                        $gallery_index++;
                    }
                }

				$galleryname=$parsedusername."_".str_replace(" ", "_",$gallery_index);
				$absolute_path = $imggallerypath.$galleryname;
				$temp=mkdir($absolute_path, 0777);
				$log_action="GALLERY_CREATED";
				$posterID=$username;
				$galleryInfo=array($posterID, $date, $gallerytitle, $gallerydesc, $sortOrder, $downloadLink, $gallerycopyright, $concealPath);
                        }else{
				$log_action="GALLERY_DETAILS_EDITED";
			}

                        if (file_exists($absolute_path."/index.php")) {
                        	$galleryInfo="";
                        	include $imggallerypath.$galleryname."/index.php";
                        	$posterID=trim($galleryInfo[0]);

				if($posterID==""){
					$posterID=$username;
				}

				if(!can_edit($galleryname, $_SESSION['s_userName'])){
	                                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
	                                break;
	                        }
                        }

                                
                        //this is where we go ahead and write out our index.php which contains the gallery info
                        $handle=fopen($absolute_path.'/index.php', 'w+');
                        flock($handle, LOCK_EX);

                        fwrite($handle, "<?php\n");
                        fwrite($handle, "if(ISSET(\$includeFlag)){\n");
                        fwrite($handle, "\$galleryInfo=array('{$posterID}', '{$date}', '{$gallerytitle}', '{$gallerydesc}', '{$sortOrder}', '{$downloadLink}', '{$gallerycopyright}', '{$concealPath}');\n");
                        fwrite($handle, "}else{\n");
                        fwrite($handle, "echo \"<html><head><title>Access Denied</title></head><body>Access Denied</body></html>\";\n");
                        fwrite($handle, "}\n");
                        fwrite($handle, "?>\n");
                                
                        flock($handle, LOCK_UN);
                        fclose($handle);

			log_action("$log_action", "SUCCESS", $galleryname, "\"".implode("  --  ", $galleryInfo)."\"");

			if($vm!='ajax'){
	                        header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
                        }else{
                                echo "<script type='text/javascript'>
                                        parent.$.fn.colorbox.close();
        	                        </script>";
                        }
                        break;

		default:
			header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
			break;
	}
}else{
	header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?error=GCsuccessful");
}
?>
