<?php
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: swif.uploader.script.php                                  #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

include_once '../config.php';
include_once '../themes/'.$themeName.'/options.php';
include '../functions.php';

$sessionid='';
if(isset($_GET['sessionid'])){
     $sessionid=$_GET['sessionid'];    
}else if(isset($_POST['sessionid'])){   
     $sessionid=$_POST['sessionid'];
}

session_name($sessionIdentifier);
session_id($sessionid);
session_start();

$imggallerypath='../galleries/';

$galleryname='';
if(isset($_GET['galleryname'])){
     $galleryname=$_GET['galleryname'];
}

$mode='';
if(isset($_POST['mode'])){             
     $mode=$_POST['mode'];     
}

$vm='';       
if(isset($_POST['vm'])){
     $vm=$_POST['vm'];
}

$absolute_path=$imggallerypath.$galleryname."/";

if(!isset($_SESSION['s_userName'])) {
	header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
	break;
}

if(!can_edit($galleryname, $_SESSION['s_userName'])){
	header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
	break;
}

$result = array();

if (isset($_FILES['photos']) )
{
        if($enableUploadLimitOverride){
            @ini_set("upload_max_filesize", $uploadLimit);
            @ini_set("post_max_size", $uploadLimit);
	}

	$file = $_FILES['photos']['tmp_name'];
	$error = false;
	if( ($mode=="single_file" && trim($_FILES['photos']['name'])=="") || ($mode=="single_file" && (!is_image($_FILES['photos']['name']) && !is_movie($_FILES['photos']['name'])))){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?action=uploadimages&galleryname=".$galleryname."&vm=".$vm);
		exit();
	}

	//make sure we want to process this file. If not we're being hacked. Die.
	if(!is_image($_FILES['photos']['name']) && !is_movie($_FILES['photos']['name'])){
		log_action("UPLOAD", "FAILED", $galleryname, "ATTEMPT TO UPLOAD UNSUPPORTED FILE - {$_FILES['photos']['name']}) {$_FILES['photos']['size']} byte(s)");
		die("NO HACK PROTECTION ACTIVATED");
	}

	//sanitize our file name so it doesnt come back to bite us in the butt
        $search= array("lowres_", "thm_");
        $destroy = array("_", "_");
        $_FILES['photos']['name']=str_replace($search, $destroy, $_FILES['photos']['name']);
        $_FILES['photos']['name']=strip_tags($_FILES['photos']['name']);
        $_FILES['photos']['name']=html_entity_decode($_FILES['photos']['name']);
        $_FILES['photos']['name']=urldecode($_FILES['photos']['name']);

	//if the file name exists do not overwrite it. Resolve the conflict gracefully.
	$ext=substr($_FILES['photos']['name'], strrpos($_FILES['photos']['name'], ".") +1);
        $tmpfilename=substr($_FILES['photos']['name'], 0, strrpos($_FILES['photos']['name'], "."));
	if(file_exists($absolute_path.$_FILES['photos']['name'])){
		$x=1;

		while(file_exists($absolute_path.$_FILES['photos']['name'])){
			if(!file_exists($absolute_path.$tmpfilename."_".$x.$ext)){
				$_FILES['photos']['name']=$tmpfilename."_".$x.".".$ext;
			}
			$x++;
		}
	}

	if ($error){
		$result['result'] = 'failed';
		$result['error'] = $error;
		$error=true;
	}else{

	       	if(move_uploaded_file($file, $absolute_path.$_FILES['photos']['name'])){
			@chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);

			$result['result'] = 'success';
			$result['size'] = "File Uploaded Successfully";
			

			/* If the image was successfully uploaded lets 
			   go ahead and create the thumbnail  and lowres 
			   images now. If a user ftp's images into a directory 
			   they will be processed in the main loop. Its more efficient
			   to handle thm processing now however. Image sizes are 
			   taken from the template options. */

			$imagedimensions = getimagesize($absolute_path.$_FILES['photos']['name']);

	  		if(strtolower(substr($_FILES['photos']['name'], (strlen($_FILES['photos']['name'])-3), 3)) == 'jpg') {
				if(!(file_exists($absolute_path."thm_".$_FILES['photos']['name']))){
					if($imagedimensions[0] > $imagedimensions[1]){
					    resizeJPG($absolute_path.$_FILES['photos']['name'], 
						$absolute_path."thm_".$_FILES['photos']['name'], $thmimagewidth, '0');
					    @chmod($absolute_path."thm_".$_FILES['photos']['name'], $chmodPermissions);

                                            if($restrictUploadedImageDimensions){
                                                if($imagedimensions[0] > $maxUploadedWidth){
						    resizeJPG($absolute_path.$_FILES['photos']['name'],
                                                       $absolute_path.$_FILES['photos']['name'], $maxUploadedWidth, '0');
						    @chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);
						}  
                                            }
					    $imagedimensions = getimagesize($absolute_path.$_FILES['photos']['name']);

					    if($imagedimensions[0] > $imagesdisplaywidth){
                                                resizeJPG($absolute_path.$_FILES['photos']['name'],
                                                   $absolute_path."lowres_".$_FILES['photos']['name'], $imagesdisplaywidth, '0');					
						@chmod($absolute_path."lowres_".$_FILES['photos']['name'], $chmodPermissions);
					    }
					}else{
                                    	    resizeJPG($absolute_path.$_FILES['photos']['name'], 
						$absolute_path."thm_".$_FILES['photos']['name'], '0', $thmimageheight);
					    @chmod($absolute_path."thm_".$_FILES['photos']['name'], $chmodPermissions);

                                            if($restrictUploadedImageDimensions){
                                                if($imagedimensions[1] > $maxUploadedHeight){
                                                    resizeJPG($absolute_path.$_FILES['photos']['name'],
                                                    $absolute_path.$_FILES['photos']['name'], $maxUploadedHeight, '0');
						    @chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);
                                                }
                                            }
                                            $imagedimensions = getimagesize($absolute_path.$_FILES['photos']['name']);

					    if($imagedimensions[1] > $imagesdisplayheight){
                                              resizeJPG($absolute_path.$_FILES['photos']['name'],
                                                $absolute_path."lowres_".$_FILES['photos']['name'], '0', $imagesdisplayheight);
					      @chmod($absolute_path."lowres_".$_FILES['photos']['name'], $chmodPermissions);
					    }
					}
  				}
			}
                        if(strtolower(substr($_FILES['photos']['name'], (strlen($_FILES['photos']['name'])-3), 3)) == 'gif') {
                                if(!(file_exists($absolute_path."thm_".$_FILES['photos']['name']))){
                                        if($imagedimensions[0] > $imagedimensions[1]){
                                            resizeGIF($absolute_path.$_FILES['photos']['name'], 
						$absolute_path."thm_".$_FILES['photos']['name'], $thmimagewidth, '0');
					    @chmod($absolute_path."thm_".$_FILES['photos']['name'], $chmodPermissions);

                                            if($restrictUploadedImageDimensions){
                                                if($imagedimensions[0] > $maxUploadedWidth){
                                                    resizeGIF($absolute_path.$_FILES['photos']['name'],
                                                       $absolute_path.$_FILES['photos']['name'], $maxUploadedWidth, '0');
						    @chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);
                                                }
                                            }
                                            $imagedimensions = getimagesize($absolute_path.$_FILES['photos']['name']);

					    if($imagedimensions[0] > $imagesdisplaywidth){
                                                resizeGIF($absolute_path.$_FILES['photos']['name'],
                                                    $absolute_path."lowres_".$_FILES['photos']['name'], $imagesdisplaywidth, '0');
						@chmod($absolute_path."lowres_".$_FILES['photos']['name'], $chmodPermissions);
					    }
                                        }else{
                                            resizeGIF($absolute_path.$_FILES['photos']['name'], 
						$absolute_path."thm_".$_FILES['photos']['name'], '0', $thmimageheight);
					    @chmod($absolute_path."thm_".$_FILES['photos']['name'], $chmodPermissions);

                                            if($restrictUploadedImageDimensions){
                                                if($imagedimensions[1] > $maxUploadedHeight){
                                                    resizeGIF($absolute_path.$_FILES['photos']['name'],
                                                    $absolute_path.$_FILES['photos']['name'], $maxUploadedHeight, '0');
						    @chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);
                                                }
                                            }
                                            $imagedimensions = getimagesize($absolute_path.$_FILES['photos']['name']);

					    if($imagedimensions[1] > $imagesdisplayheight){
                                                resizeGIF($absolute_path.$_FILES['photos']['name'],
                                                   $absolute_path."lowres_".$_FILES['photos']['name'], '0', $imagesdisplayheight);
						@chmod($absolute_path."lowres_".$_FILES['photos']['name'], $chmodPermissions);
					    }
                                        }
                                }
                        }
                        if(strtolower(substr($_FILES['photos']['name'], (strlen($_FILES['photos']['name'])-3), 3)) == 'png') {
                                if(!(file_exists($absolute_path."thm_".$_FILES['photos']['name']))){
                                        if($imagedimensions[0] > $imagedimensions[1]){
                                            resizePNG($absolute_path.$_FILES['photos']['name'], 
						$absolute_path."thm_".$_FILES['photos']['name'], $thmimagewidth, '0');
					    @chmod($absolute_path."thm_".$_FILES['photos']['name'], $chmodPermissions);

                                            if($restrictUploadedImageDimensions){
                                                if($imagedimensions[0] > $maxUploadedWidth){
                                                    resizePNG($absolute_path.$_FILES['photos']['name'],
                                                       $absolute_path.$_FILES['photos']['name'], $maxUploadedWidth, '0');
						    @chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);
                                                }
                                            }   
                                            $imagedimensions = getimagesize($absolute_path.$_FILES['photos']['name']);

					    if($imagedimensions[0] > $imagesdisplaywidth){
                                                resizePNG($absolute_path.$_FILES['photos']['name'],
                                                   $absolute_path."lowres_".$_FILES['photos']['name'], $imagesdisplaywidth, '0');
						@chmod($absolute_path."lowres_".$_FILES['photos']['name'], $chmodPermissions);
					    }
                                        }else{
                                            resizePNG($absolute_path.$_FILES['photos']['name'], 
						$absolute_path."thm_".$_FILES['photos']['name'], '0', $thmimageheight);
					    @chmod($absolute_path."thm_".$_FILES['photos']['name'], $chmodPermissions);

                                            if($restrictUploadedImageDimensions){
                                                if($imagedimensions[1] > $maxUploadedHeight){
                                                    resizePNG($absolute_path.$_FILES['photos']['name'],
                                                    $absolute_path.$_FILES['photos']['name'], $maxUploadedHeight, '0');
						    @chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);
                                                }
                                            }
                                            $imagedimensions = getimagesize($absolute_path.$_FILES['photos']['name']);

					    if($imagedimensions[1] > $imagesdisplayheight){
                                                resizePNG($absolute_path.$_FILES['photos']['name'],
                                                   $absolute_path."lowres_".$_FILES['photos']['name'], '0', $imagesdisplayheight);
						@chmod($absolute_path."lowres_".$_FILES['photos']['name'], $chmodPermissions);
					    }
                                        }
                                }
                        }
                        if(strtolower(substr($_FILES['photos']['name'], (strlen($_FILES['photos']['name'])-4), 4)) == 'jpeg') {
                                if(!(file_exists($absolute_path."thm_".$_FILES['photos']['name']))){
                                        if($imagedimensions[0] > $imagedimensions[1]){
                                            resizeJPG($absolute_path.$_FILES['photos']['name'], 
						$absolute_path."thm_".$_FILES['photos']['name'], $thmimagewidth, '0');
					    @chmod($absolute_path."thm_".$_FILES['photos']['name'], $chmodPermissions);

                                            if($restrictUploadedImageDimensions){
                                                if($imagedimensions[0] > $maxUploadedWidth){
                                                    resizeJPG($absolute_path.$_FILES['photos']['name'],
                                                       $absolute_path.$_FILES['photos']['name'], $maxUploadedWidth, '0');
						    @chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);
                                                }
                                            }
                                            $imagedimensions = getimagesize($absolute_path."/".$_FILES['photos']['name']);

					    if($imagedimensions[0] > $imagesdisplaywidth){
                                                resizeJPG($absolute_path.$_FILES['photos']['name'],
                                                   $absolute_path."lowres_".$_FILES['photos']['name'], $imagesdisplaywidth, '0');
						@chmod($absolute_path."lowres_".$_FILES['photos']['name'], $chmodPermissions);
					    }
                                        }else{
                                            resizeJPG($absolute_path.$_FILES['photos']['name'], 
						$absolute_path."thm_".$_FILES['photos']['name'], '0', $thmimageheight);
					    @chmod($absolute_path."thm_".$_FILES['photos']['name'], $chmodPermissions);

                                            if($restrictUploadedImageDimensions){
                                                if($imagedimensions[1] > $maxUploadedHeight){
                                                    resizeJPG($absolute_path.$_FILES['photos']['name'],
                                                    $absolute_path.$_FILES['photos']['name'], $maxUploadedHeight, '0');
						    @chmod($absolute_path.$_FILES['photos']['name'], $chmodPermissions);
                                                }
                                            }
                                            $imagedimensions = getimagesize($absolute_path.$_FILES['photos']['name']);

					    if($imagedimensions[1] > $imagesdisplayheight){
                                                resizeJPG($absolute_path.$_FILES['photos']['name'],
                                                   $absolute_path."lowres_".$_FILES['photos']['name'], '0', $imagesdisplayheight);
						@chmod($absolute_path."lowres_".$_FILES['photos']['name'], $chmodPermissions);
					    }
                                        }
                                }
                        }

		}else{
			$result['result'] = 'error';
			$result['error'] = 'Missing file or internal error!';
			$error=true;
		}

	}

}else{
	$result['result'] = 'error';
	$result['error'] = 'Missing file or internal error!';
	$error=true;
}

//LOG OUR UPLOAD
//log( ACTION, STATUS, GALLERYNAME, DETAILS);
log_action("UPLOAD", ($error ? 'FAILED' : 'SUCCESS'), $galleryname, "{$tmpfilename}.{$ext} (stored as {$_FILES['photos']['name']}) {$_FILES['photos']['size']} byte(s)");

if($mode=="single_file"){
	echo "<script type='text/javascript'>
                     parent.$.fn.colorbox.close();
              </script>";
}else{
	if (!headers_sent() ){
		header('Content-type: application/json');
	}

	echo json_encode($result);
}

?>
