<?php
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: functions.php                                             #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

function get_head(){
	global $galleryTitle;
	global $galleryDescription;
	global $styleSheetPath;
	global $scriptsPath;
	global $title;
	global $a;
	global $gallery;
	global $loopvars;

	echo "<title>$galleryTitle - powered by: Panda Image Gallery</title>
              <meta name='description' content='$galleryDescription - powered by: Panda Image Gallery' />
              <link rel='alternate' type='application/rss+xml' title='$galleryTitle - Main' href='rss.xml.php' />

              <link rel='stylesheet' TYPE='text/css' HREF='{$styleSheetPath}content.css' />
              <link rel='stylesheet' TYPE='text/css' HREF='{$styleSheetPath}colorbox.css' />

              <!-- jquery -->
              <script type='text/javascript' src='{$scriptsPath}jquery/jquery-1.3.2.min.js'></script>

              <!-- colorbox integration -->
              <script type='text/javascript' src='{$scriptsPath}colorbox/jquery.colorbox-min.js'></script>

	      <!-- Flowplayer -->
	      <script type='text/javascript' src='{$scriptsPath}flowplayer/flowplayer-3.2.6.min.js'></script>

              <script type='text/javascript'>
                   if ('undefined' == typeof(PandaImageGallery)) {
                           var PandaImageGallery = {};
                   };
                   PandaImageGallery.pageRefresh=0;
              </script>";

	      if($a=='vg' || $a=='vi'){
                   echo "<link rel='alternate' type='application/rss+xml' title='$title Image Feed' href='rssgallery.xml.php?g={$gallery}' />";
              }

	$loopvars->set_var("get_head", true);
}

function get_content(){
	global $loopvars;

	$loopvars->echo_var("body_content");

	$loopvars->set_var("get_content", true);
}

function get_sort(){
	global $loopvars;
	
	$loopvars->echo_var("sort_form");
}

function get_footer(){

	global $show_sitemap;
	global $is_premium;
	global $sitemapURL;
	global $target;
	global $copyright;
	global $loopvars;

	if($show_sitemap==1){
		echo "<div class='sitemap'><a href='{$sitemapURL}' $target>Sitemap XML</a></div>";
	}

	if($is_premium!=1){
		echo "<div class='copyright'><span class='copyright'>$copyright</span></div>";
	}

	echo "<img src='loading.gif' style='display: none;' />";

	$loopvars->set_var("get_footer", true);
}

function get_gallery_details($galleryPath){

	global $includeFlag;
	$galleryInfo="";

	if (file_exists($galleryPath."/index.php")) {

		ob_start();
		include $galleryPath."/index.php";
		ob_end_clean();

		if(is_array($galleryInfo)){

			//PRE-PROCESSING HERE
			//$galleryInfo[0]; //Poster ID
			//$galleryInfo[1]; //Date Posted
			//$galleryInfo[2];  //Gallery Title
			//$galleryInfo[3];  //Description
			//$galleryInfo[5];  //Allow Download Flag
			//$galleryInfo[6];  //Gallery Copyright
			//$galleryInfo[7];  //Conceal image path flag

			if(stristr($galleryInfo[1], "@")){
				$galleryInfo[1]=explode("@", $galleryInfo[1]);
				$galleryInfo[1][1]=substr($galleryInfo[1][1], 1, strlen($galleryInfo[1][1]));

				if($showPostTime==1){
					$galleryInfo[1][1]=date("g:ia", $galleryInfo[1][1]);
					$galleryInfo[1]=$galleryInfo[1][0]." at ".$galleryInfo[1][1];
				}else{
					$galleryInfo[1]=$galleryInfo[1][0];
				}
			}

		} else {

			$galleryInfo[0]="Unavailable";
			$galleryInfo[1]="Unavailable";
			$galleryInfo[2]="Title Unknown";
			$galleryInfo[3]="No description given";
			$galleryInfo[5]='0';
			$galleryInfo[6]="";
			$galleryInfo[7]=0;
		}
	} else {
		$galleryInfo[0]="Unavailable";
		$galleryInfo[1]="Unavailable";
		$galleryInfo[2]="Title Unknown";
		$galleryInfo[3]="No description given";
		$galleryInfo[5]='0';
		$galleryInfo[6]="";
		$galleryInfo[7]=0;
	}

	return $galleryInfo;
}

//This function checks whether a user can manip a gallery.
//Admins can edit any gallery. Regular users can only edit their own gallery.
function can_edit($gallery, $user){
	include 'users/users.inc.php';

	$parsedusername=str_replace(" ", "", $user);

	if( (trim($user)!="" && substr($gallery, 0, strlen($parsedusername))==$parsedusername) || (trim($user)!="" && $users["{$user}"][5]=="admin")){
		return true;
	}else{
		return false;
	}

	return false;
}

function is_movie($filename){

	$ext=strtolower(substr($filename, strrpos($filename, ".") +1));
        if( $ext == 'avi'
                || $ext == 'flv'                                                    
                || $ext == 'mov'
		|| $ext == 'mpg'
		|| $ext == 'mpeg'
		|| $ext == 'mp4'
                || $ext == 'wmv'){

		return true;
		exit();
	}else{
		return false;
		exit();
	}

	return false;
	exit();
}

function is_image($filename){
	
	$ext=strtolower(substr($filename, strrpos($filename, ".") +1));
        if( $ext == 'jpg'
                || $ext == 'jpeg'
                || $ext == 'gif'
                || $ext == 'png'){

                return true;
                exit();
        }else{
                return false;
                exit();
        }
        
        return false;
        exit();
}

//this function returns the current date in 4/4/2003 format
function currentDate(){ 
        //this function produces the date in the format of 4/3/2003
        //the date is then returned
        $swap = getdate();
        $today = "{$swap['mon']}/{$swap['mday']}/{$swap['year']}";
        return $today;
}                       
                        
function natcasesort2d(&$aryInput) {
//this function will sort an array without maintaining keys
  $aryOut='';                   
                        
  $aryTemp = $aryInput;         
                                        
  if(is_array($aryTemp))                
     natcasesort($aryTemp);
                        
  if(!empty($aryTemp)){
    foreach ($aryTemp as $value) { //natcasesort will sort our array but it also preserves key associations
      $aryOut[] = $value;           //this way we step through a create a fresh array with no associations
    }                   
  }                     
  $aryInput = $aryOut;           //return array
}

//Benchmark code
if($benchmark){
        $total = $bench->gettime();
        echo "Total execution time: $total<br />\n";
}
        
//Thanks to Brian Stanback for this simple execution timer
class Timer {
        function getmicrotime() {
                list($usec, $sec) = explode(" ", microtime());
                return ((float)$usec + (float)$sec);
        }       
        function starttime() {
                $this->st = $this->getmicrotime();
        }
        function gettime() {
                $this->et = $this->getmicrotime();
                return round(($this->et - $this->st), 5);
        }
}         
        
function locateCurrentImagePosition($i, $images){
    $x=0;
    for ($x = 0; $x <= count($images); $x++) {
        if($images[$x][0]==$i)
            return $x;
    }   
        
    return -1;  
         
}

function format_bytes($size) {
    $units = array(' B', ' KB', ' MB', ' GB', ' TB');
    for ($i = 0; $size >= 1024 && $i < 4; $i++) $size /= 1024;
    return round($size, 0).$units[$i];
}

function resizeJPG($sourceimage, $destinationimage, $newwidth, $newheight){

        global $memoryLimit;
	global $enableMemoryLimitOverride;

	//Variables used in this script
	//IT IS ONLY NECESSARY TO PASS ONE OF THE NEW DIMENSIONS AS THE OTHER
	//DIMENSION IS CACULATED.
	//
	//Pass the unknown dimension as the number 0
	//
	//$newwidth   <--Width of resized image
	//$newheight  <--Height of resized image
	//$sourceimage <--Source to resize
	//$destinationimage <--Image name to output

	if($enableMemoryLimitOverride)
		@ini_set("memory_limit", $memoryLimit);

	//get the current image dimensions
	$imagedimensions = getimagesize($sourceimage);

	//see if a dimension was passed, if so then calculate the other dim.
	//if both dims were passed then do nothing.
	if((!$newwidth && !$newheight) || ($newwidth==0 && $newheight==0)){
		die ('must specify at least one dimension');
	}

	if(!$newwidth || $newwidth==0){
		$temph=($newheight/$imagedimensions[1]);
		$newwidth=intval($temph*$imagedimensions[0]);
	}

	if(!$newheight || $newheight==0){
		$temph=($newwidth/$imagedimensions[0]);
		$newheight=intval($temph*$imagedimensions[1]);
	}

	//create pointers to work with
	$img_src=imagecreatefromjpeg($sourceimage);
	$img_dst=imagecreatetruecolor($newwidth,$newheight);

	//resize and output the image
	imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $newwidth, $newheight, $imagedimensions[0], $imagedimensions[1]);
	imagejpeg($img_dst, $destinationimage);

	//clean up after ourselves.
	imagedestroy($img_dst);
	imagedestroy($img_src);
	$destinationimage="";
	$temph="";
	$tempwidth="";
	$tempheight="";
	$sourceimage="";
	$newwidth="";
	$newheight="";
}

function resizePNG($sourceimage, $destinationimage, $newwidth, $newheight){

        global $memoryLimit;
	global $enableMemoryLimitOverride;

	//Variables used in this script
	//IT IS ONLY NECESSARY TO PASS ONE OF THE NEW DIMENSIONS AS THE OTHER
	//DIMENSION IS CACULATED.
	//
	//Pass the unknown dimension as the number 0
	//
	//$newwidth   <--Width of resized image
	//$newheight  <--Height of resized image
	//$sourceimage <--Source to resize
	//$destinationimage <--Image name to output

	if($enableMemoryLimitOverride)
		@ini_set("memory_limit", $memoryLimit);

	//get the current image dimensions
	$imagedimensions = getimagesize($sourceimage);


	//see if a dimension was passed, if so then calculate the other dim.
	//if both dims were passed then do nothing.
	if((!$newwidth && !$newheight) || ($newwidth==0 && $newheight==0)){
		die ('must specify at least one dimension');
	}

        if(!$newwidth || $newwidth==0){
                $temph=($newheight/$imagedimensions[1]);
                $newwidth=intval($temph*$imagedimensions[0]);
        }

        if(!$newheight || $newheight==0){
                $temph=($newwidth/$imagedimensions[0]);
                $newheight=intval($temph*$imagedimensions[1]);
        }

	//create pointers to work with
	$img_src=imagecreatefrompng($sourceimage);
	$img_dst=imagecreatetruecolor($newwidth,$newheight);

	//resize and output the image
	imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $newwidth, $newheight, $imagedimensions[0], $imagedimensions[1]);
	imagepng($img_dst, $destinationimage);
	imagedestroy($img_dst);
}


//This was a workaround to no gif write support until the patent expiration
//in JULY 2004, it reads in a gif but saves the gif as a jpg.  The result
//is a gif resized and saved in jpeg format
function resizeGIF2JPEG($sourceimage, $destinationimage, $newwidth, $newheight){

        global $memoryLimit;
	global $enableMemoryLimitOverride;

	//Variables used in this script
	//IT IS ONLY NECESSARY TO PASS ONE OF THE NEW DIMENSIONS AS THE OTHER
	//DIMENSION IS CACULATED.
	//
	//Pass the unknown dimension as the number 0
	//
	//$newwidth   <--Width of resized image
	//$newheight  <--Height of resized image
	//$sourceimage <--Source to resize
	//$destinationimage <--Image name to output

	if($enableMemoryLimitOverride)
		@ini_set("memory_limit", $memoryLimit);

	//get the current image dimensions
	$imagedimensions = getimagesize($sourceimage);


	//see if a dimension was passed, if so then calculate the other dim.
	//if both dims were passed then do nothing.
	if((!$newwidth && !$newheight) || ($newwidth==0 && $newheight==0)){
		die ('must specify at least one dimension');
	}

        if(!$newwidth || $newwidth==0){
                $temph=($newheight/$imagedimensions[1]);
                $newwidth=intval($temph*$imagedimensions[0]);
        }

        if(!$newheight || $newheight==0){
                $temph=($newwidth/$imagedimensions[0]);
                $newheight=intval($temph*$imagedimensions[1]);
        }

	//create pointers to work with
	$img_src=imagecreatefromgif($sourceimage);
	$img_dst=imagecreatetruecolor($newwidth,$newheight);

	//resize and output the image
	imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $newwidth, $newheight, $imagedimensions[0], $imagedimensions[1]);
	imagejpeg($img_dst, $destinationimage);
	imagedestroy($img_dst);
}

function resizeGIF($sourceimage, $destinationimage, $newwidth, $newheight){

        global $memoryLimit;
	global $enableMemoryLimitOverride;

	//Variables used in this script
	//IT IS ONLY NECESSARY TO PASS ONE OF THE NEW DIMENSIONS AS THE OTHER
	//DIMENSION IS CACULATED.
	//
	//Pass the unknown dimension as the number 0
	//
	//$newwidth   <--Width of resized image
	//$newheight  <--Height of resized image
	//$sourceimage <--Source to resize
	//$destinationimage <--Image name to output

	if($enableMemoryLimitOverride)
		@ini_set("memory_limit", $memoryLimit);

	//get the current image dimensions
	$imagedimensions = getimagesize($sourceimage);


	//see if a dimension was passed, if so then calculate the other dim.
	//if both dims were passed then do nothing.
	if((!$newwidth && !$newheight) || ($newwidth==0 && $newheight==0)){
		die ('must specify at least one dimension');
	}

        if(!$newwidth || $newwidth==0){
                $temph=($newheight/$imagedimensions[1]);
                $newwidth=intval($temph*$imagedimensions[0]);
        }

        if(!$newheight || $newheight==0){
                $temph=($newwidth/$imagedimensions[0]);
                $newheight=intval($temph*$imagedimensions[1]);
        }

	//create pointers to work with
	$img_src=imagecreatefromgif($sourceimage);
	$img_dst=imagecreatetruecolor($newwidth,$newheight);

	//resize and output the image
	imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $newwidth, $newheight, $imagedimensions[0], $imagedimensions[1]);
	imagegif($img_dst, $destinationimage);
	imagedestroy($img_dst);
}

function log_action($action, $status, $galleryname, $details){

	global $imggallerypath;
	
        //LOG OUR UPLOAD
        $addr = gethostbyaddr($_SERVER['REMOTE_ADDR']);   
            
        if(!file_exists($imggallerypath."logs/".$galleryname.".log.csv")){
                $firstline="DATE_TIME, USERNAME, ACTION, STATUS, HOST, DETAILS";
        }else{
                $firstline=false;
        }
        $log = @fopen($imggallerypath."logs/".$galleryname.".log.csv", 'a');
        if($firstline){
                @fputs($log, $firstline."\n");
        }
        @fputs($log, date("m/d/y g:i a").", {$_SESSION['s_userName']}, {$action}, {$status}, {$addr}, {$details}\n" );
        @fclose($log);

}
?>
