<?php
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: index.php                                                 #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

error_reporting(0);
//error_reporting(E_ALL);

if(!file_exists("./config.php")){
    die("<b>You must configure Panda Image Gallery! <br/><br/>Please review config.php.sample, configure as necessary,
	and rename config.php.sample to config.php. <br/><br/>See the README or installation notes for installation details.</b>");
}

$galleriesRoot="galleries/";

//enable benchmarking code
$benchmark=0;
if($benchmark){
    //benchmark code
    $bench = new Timer;
    $bench->starttime();
}

//lets determine what our user named us
$scripttemp=$_SERVER['PHP_SELF'];
//$pageFileName = substr($scripttemp, (strrpos($scripttemp, "/")+1), (strlen($scripttemp)));

$imgNameHTMLCommentOpen='';
$imgNameHTMLCommentClose='';

include_once './config.php';
include_once 'class/panda_dir.php';
include_once 'functions.php';

include_once 'class/loopvars.php';
$loopvars = new clsLoopVars();


// ############## ADVANCED OPTIONS - DO NOT LOOK BELOW UNLESS YOU ARE A CODER ############ \\
//you can use this to integrate the image gallery with a sites login methods. It is not openly supported but
//has been included as a courtesy
$siteIntegration=0; //enable or disable intregration mode
$adminURL="panda_image_gallery/admin/imggallerymgmt.php"; //passed to login script for return after login
// ############# END LOGIN INTEGRATION OPTION ############################################ \\

@session_name($sessionIdentifier);
@session_start();

if((isset($_GET['cms']) && $_GET['cms']==1 && $unified_mode==1) || (isset($_POST['cms']) && $_POST['cms']==1 && $unified_mode==1) || ($_SESSION['cms']==1 && $unified_mode==1) || $unified_mode==2){
    $cms=1;
    $_SESSION['cms']=1;
    $target=" target='_top' "; 
    $pageFileName=$base_url;
    $cms_link="&cms=1";
    $cms_link2="?cms=1";
}else{
    $cms=0;
    $_SESSION['cms']=0;
    $pageFileName = substr($scripttemp, (strrpos($scripttemp, "/")+1), (strlen($scripttemp)));
    $cms_link="";
    $cms_link2="";
}

$version_string="3.5.8";
$themeName='themes/'.$themeName;
$styleSheetPath=$themeName.'/';
$templateImages=$themeName."/images";
$managementPath='admin/index.php'.$cms_link2;
$scriptsPath='scripts/';
$registrationPath=$pageFileName."?a=reg";
$passwordRecoveryPath=$pageFileName."?a=pr";
$ajaxLoginPath="admin/index.php?action=plainlogin&amp;cms=$cms";
$loginPath='admin/login.php';
$logoutPath='admin/logout.php';
$chgPassPath=$pageFileName;
$sitemapURL='sitemap.xml.php';

include_once $themeName.'/options.php';

if($hideThumbnailImgName==0){
    $imgNameHTMLCommentOpen='<!--';
    $imgNameHTMLCommentClose='-->';
}else{
    $imgNameHTMLCommentOpen='';
    $imgNameHTMLCommentClose='';
}

$a='';
$currentpage='';
$previouspage='';
$nextpage='';
$pageoutstringA='';
$iptc='';
$gallerycount='';
$imagesize='';
$i='';
$pg='';
$topLeftCorner=1;
$gp='';
$appendGP='';
$appendPG1='';
$appendPG2='';
$username='';
$galleryListingSortOrder='';
$galleryViewSortOrder='';
$r='';
$searchTerm='';
$templateUpload='';
$templateEditGallery='';
$templateCreateGallery='';
$templateDownloadImage='';
$templateSearchForm='';
$templateSortBy='';

$includeFlag='1'; //only way for our included files to know their included.

if(isset($_GET['a'])){
    $a=$_GET['a'];
    $loopvars->set_var("action", $_GET['a']);
}

if(isset($_GET['g']))
    $gallery=$_GET['g'];

if(isset($_GET['r']))
    $r=$_GET['r'];

if(isset($_GET['image']))
    $image=$_GET['image'];

if(isset($_GET['cp']))
    $currentpage=$_GET['cp'];

if(isset($_GET['i']))
    $i=html_entity_decode($_GET['i'], ENT_QUOTES);

if(isset($_GET['gp']))
    $gp=$_GET['gp'];

if(isset($_GET['pg']))
    $pg=$_GET['pg'];

if(isset($_GET['q']))
    $searchTerm=trim($_GET['q']);

if(isset($_POST['galleryListingSortOrder']))
    $_SESSION['s_galleryListingSortOrder']=$_POST['galleryListingSortOrder'];

if(isset($_POST['galleryViewSortOrder']))
    $_SESSION['s_galleryViewSortOrder']=$_POST['galleryViewSortOrder'];

if(isset($_SESSION['s_userName']))
        $username=$_SESSION['s_userName'];

$currentImageName='';
$highres=0;

$currentURL=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];

//set default gallery sort order is none is selected
if(!isset($_SESSION['s_galleryListingSortOrder'])){
	$_SESSION['s_galleryListingSortOrder']=$defaultGallerySortOrder;
}
//set default view gallery sort order is none is selected
if(!isset($_SESSION['s_galleryViewSortOrder'])){
        $_SESSION['s_galleryViewSortOrder']=$defaultImageSortOrder;
}
$galleryListingSortOrder=$_SESSION['s_galleryListingSortOrder'];
$galleryViewSortOrder=$_SESSION['s_galleryViewSortOrder'];

//maintain gallery listing page for link backs
if($gp!=''){
    $appendGP="&gp=$gp";
    $appendGP2="?gp=$gp";
    $appendPG="&pg=$pg";
}else{
     $appendPG="?pg=$pg";
}

//personal gallery capability
if($pg!=''){
    $appendPG1="&pg=$pg";
    $appendPG2="?pg=$pg";
    $backtogallerylink=$pageFileName.$appendGP2.$appendPG;
}else{
    $backtogallerylink=$pageFileName.$appendGP2;
}

$_SESSION['viewimage']=1;

/* DO NOT REMOVE OR MODIFY THIS COPYRIGHT NOTICE UNLESS YOU HAVE PURCHASES A LICENSE WHICH PERMITS ITS REMOVAL OR 
   MODIFICATION. YOU ARE REQUIRED TO LINK BACK TO MY WEBSITE AND THIS PROJECTS PAGE.
*/
$is_premium=0;
$copyright='<a href="http://www.schiffner.com/index.php/coding-projects/panda-image-gallery/" target="_blank">
Panda Image Gallery v'.$version_string.'</a> - &copy; 2010 Christopher Schiffner - All Rights Reserved';

$ajaxifythumb=" onClick='$(this).colorbox({width:\"600px\", height:\"500px\", overlayClose: false, iframe:true, next: false, title: \" \", previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed: function(){ PandaImageGallery.pageRefresh=0;} });' ";
$ajaxifycaption=" onClick=' $(this).colorbox({width:\"600px\", height:\"400px\", overlayClose: false, iframe:true, next: false, title: \" \", previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed: function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); }PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifycaptionNoRefresh=" onClick='PandaImageGallery.overrideRefresh=1; $(this).colorbox({width:\"600px\", height:\"400px\", overlayClose: false, iframe:true, next: false, title: \" \", previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed: function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); }PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifydelete=" onClick='$(this).colorbox({width:\"600px\", height:\"500px\", overlayClose: false, iframe:true, next: false, title:  \" \", previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed:function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); }PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifynewgallery=" onClick='$(this).colorbox({width:\"700px\", height:\"500px\", overlayClose: false, iframe:true, next: false, title:  \" \", previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed:function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); }PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifyupload=" onClick='$(this).colorbox({width:\"650px\", height:\"80%\", overlayClose: false, iframe:true, next: false, title: \" \",  previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed:function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); } PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifylogin=" onClick='$(this).colorbox({width:\"400px\", height:\"300px\", iframe:true, next: false, title: \" \",  previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed:function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); } PandaImageGallery.pageRefresh=0; } });' ";

$templateSearchForm="<form method='get' action='{$pageFileName}' enctype='multipart/form-data' class='sortForm' $target>
                        <input type='hidden' name='cms' value='{$cms}' /> 
                        <input type='hidden' name='a' value='s' />
                        <input type='text' name='q' value='{$searchTerm}' class='searchInput' />
                        <input type='submit' value='search' class='sortFormButton' />
		     </form>";
switch ($a){

  case 'vi':

	if(!file_exists($galleriesRoot.$gallery)) {
                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']));
        }
        if(!file_exists($galleriesRoot.$gallery."/".$i)) {
                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."?a=vg&g=".$gallery);
        }

	/* VIEW IMAGE
	   this displays the image a user selected within the current gallery
	*/

	//get gallery details
	$galleryInfo=get_gallery_details($galleriesRoot.$gallery);
	$posterID=$galleryInfo[0];
	$datePosted=$galleryInfo[1];
	$title=$galleryInfo[2];
	$description=$galleryInfo[3];
	$downloadLink=$galleryInfo[5];
	$galleryCopyright=$galleryInfo[6];
	$concealPath=$galleryInfo[7];

	//get gallery contents
    $clsDirListingDefault = new clsDirListing($galleriesRoot.$gallery, 0);
    $clsDirListingDefault->sortOrder($galleryViewSortOrder);
    $clsDirListingDefault->extensionIncludes(array("jpg", "gif", "png", "avi", "mpg", "mpeg", "mov", "wmv", "jpeg", "mp4", "flv"));
	$clsDirListingDefault->prefixExcludes(array("thm_", "lowres_"));
    $images=$clsDirListingDefault->getListing();
    $clsDirListingDefault="";


	//this is the array position of the current image
	if(file_exists($galleriesRoot.$gallery."/".$i)){
	    $currentimage=locateCurrentImagePosition($i, $images);
	}else{
	    $currentimage=1;
	}
	//this was safer? It will prevent roque url malformations
	$image=$images[$currentimage][0];

    //encoded image name for links
    $linksafe_image=urlencode(htmlentities($images[$currentimage][0], ENT_QUOTES));

	//max img count is used for next/prev
	$maximagecount=(count($images)-1);

	/* THEME WANTS TO KNOW NEXT/PREV IMAGES. PROVIDE TRUE OR FALSE. TRUE = LINK TO NEXT/PREV. */
	if($currentimage!=$maximagecount){
		$nextimage=urlencode(htmlentities($images[($currentimage+1)][0], ENT_QUOTES));
	}else{
		$nextimage=0;
	}
	if($currentimage!=0){
        $previmage=urlencode(htmlentities($images[($currentimage-1)][0], ENT_QUOTES));
    }else{
        $previmage=0;
    }
    $nextimagelink="$pageFileName?g=$gallery&amp;i=$nextimage&amp;a=vi&amp;cp={$currentpage}{$appendPG1}{$appendGP}";
	$previmagelink="$pageFileName?g=$gallery&amp;i=$previmage&amp;a=vi&amp;cp={$currentpage}{$appendPG1}{$appendGP}";


	//Detect special conditions devices
	$iPod = stripos($_SERVER['HTTP_USER_AGENT'],"iPod");
	$iPhone = stripos($_SERVER['HTTP_USER_AGENT'],"iPhone");
	$iPad = stripos($_SERVER['HTTP_USER_AGENT'],"iPad");

	//this is where we end up if we are viewing an image via a
	//gallery index link.

	if(can_edit($gallery, $_SESSION['s_userName'])){
        $loginViewedImageMod="viewedImageLoggedIn";
    }else{
        $loginViewedImageMod="";
    }

	$body_content_temp="";

	if(is_movie($image)){
		
		//get filesize for display purposes. Format to be more user friendly.
		$videoFileSize=format_bytes(filesize($galleriesRoot.$gallery."/".$image));

		//movie path url
		if($protect_image_path || $concealPath){
			$fullMoviePath="http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/view.php/".$gallery."/".$image;
		}else{
			$fullMoviePath="http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$galleriesRoot.$gallery."/".$image;
		}

		$viewMoviePath="download.php/".$gallery."/".$image;
		$downloadMoviePath="download.php/".$gallery."/".$image;
		$ownPlayerLabel="Having trouble? View in your own player.";

		if( ($iPod || $iPhone || $iPad) &&  (strtolower(substr($image, (strlen($image)-3), 3)) == 'mp4')){

			if($protect_image_path || $concealPath){
				$body_content_temp.="<a class='embeddedVideo playFail'></a>";
			}else{
				$body_content_temp.="<a href='{$fullMoviePath}' class='embeddedVideo playIcon'></a>";
			}

		}else if( ($iPod || $iPhone || $iPad) &&  ((strtolower(substr($image, (strlen($image)-3), 3)) == 'flv')
							|| (strtolower(substr($image, (strlen($image)-3), 3)) == 'mov')
							|| (strtolower(substr($image, (strlen($image)-3), 3)) == 'wmv') 
							|| (strtolower(substr($image, (strlen($image)-3), 3)) == 'avi') 
							|| (strtolower(substr($image, (strlen($image)-3), 3)) == 'mpg') 
							|| (strtolower(substr($image, (strlen($image)-4), 4)) == 'mpeg')) ){

			$body_content_temp.="<a class='embeddedVideo playFail'></a>";

		}else if( (strtolower(substr($image, (strlen($image)-3), 3)) == 'mp4') 
			|| (strtolower(substr($image, (strlen($image)-3), 3)) == 'flv') ){

			$body_content_temp.="<div class='embeddedVideo viewedImage {$loginViewedImageMod} videoContainer'>

				<a href='{$fullMoviePath}' class='embeddedVideo' ID='flowplayer'></a>

				<div class='videoDetailsContainer'>
                                        <div class='videoDetailsContainerLeft'>$image ($videoFileSize)</div>
                                        <div class='videoDetailsContainerRight'>
                                                <a href='{$viewMoviePath}' target='_blank'>$ownPlayerLabel</a>
                                        </div>
                                </div>
                              </div>";

			$body_content_temp.="<!-- this will install flowplayer inside previous A- tag. -->
		        <script language='JavaScript'>flowplayer('flowplayer', {
			src: 'flash/flowplayer/flowplayer-3.2.7.swf',
			version: [9, 115],
			wmode: 'opaque'
			/* onFail: function() {
                                       //Lets make this work nicely for iOS devices. Show a link which
                                       //opens in the native player when clicked
                                       var flashfallback = document.getElementById('flashfallback');
                                       flashfallback = $(flashfallback);
                                       flashfallback.removeClass('hide');
                 
                                       //Delete the original object. No need anymore -- flash isn't supported.
                                       var node = document.getElementById('flowplayer');
                                       node.parentNode.removeChild(node);
                         } */
			      }, {
    			clip: {
       				autoPlay: true,
       				autoBuffering: true,
			       }
		      });</script>";

		}else if( (strtolower(substr($image, (strlen($image)-3), 3)) == 'avi')
				|| (strtolower(substr($image, (strlen($image)-3), 3)) == 'mpg')
				|| (strtolower(substr($image, (strlen($image)-4), 4)) == 'mpeg')
				|| (strtolower(substr($image, (strlen($image)-3), 3)) == 'wmv') ){

			//clsid:22D6F312-B0F6-11D0-94AB-0080C74C7E95
			$body_content_temp.="<div class='embeddedVideo viewedImage {$loginViewedImageMod} videoContainer'>
				<object classid='clsid:6BF52A52-394A-11D3-B153-00C04F79FAA6' codebase='http://www.microsoft.com/Windows/MediaPlayer/' class='videoObjects'>
				<param name='Filename' value='{$fullMoviePath}'>
				<param name='AutoStart' value='true'>
				<param name='ShowControls' value='true'>
				<param name='BufferingTime' value='2'>
				<param name='ShowStatusBar' value='true'>
				<param name='AutoSize' value='true'>
				<param name='InvokeURLs' value='false'>
				<embed src='{$fullMoviePath}' type='application/x-mplayer2' autostart='1' enabled='1' showstatusbar='1' showdisplay='1' showcontrols='1' pluginspage='http://www.microsoft.com/Windows/MediaPlayer/' CODEBASE='http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,0,0,0' class='videoObjects'></embed>
				</object>

				<div class='videoDetailsContainer'>
                                        <div class='videoDetailsContainerLeft'>$image ($videoFileSize)</div>
                                        <div class='videoDetailsContainerRight'>
                                                <a href='{$viewMoviePath}' target='_blank'>$ownPlayerLabel</a>
                                        </div>
                                </div>
                              </div>";
			

		}else if(strtolower(substr($image, (strlen($image)-3), 3)) == 'mov'){
			
			$body_content_temp.="<div class='embeddedVideo viewedImage {$loginViewedImageMod} videoContainer'>
				<object classid='clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B' codebase='http://www.apple.com/qtactivex/qtplugin.cab' class='videoObjects'>
				<param name='src' value='{$fullMoviePath}'>
				<param name='autoplay' value='true'>
				<param name='type' value='video/quicktime'>
				<embed src='{$fullMoviePath}' autoplay='true' type='video/quicktime' pluginspage='http://www.apple.com/quicktime/download/' class='videoObjects'>
				</object>

				<div class='videoDetailsContainer'>
                                	<div class='videoDetailsContainerLeft'>$image ($videoFileSize)</div>
                                	<div class='videoDetailsContainerRight'>
                                        	<a href='{$viewMoviePath}' target='_blank'>$ownPlayerLabel</a>
                                	</div>
                                </div>
                              </div>";
		}


		$originalImage=$image;

		if(can_edit($gallery, $_SESSION['s_userName'])){
                    $currentURLdelete=str_replace("a=vi", "a=vg", $currentURL);

               	    $body_content_temp.="<div class='adminOptions-vm'>
                    	  <a $ajaxifycaption href='admin/index.php?action=setcaption&amp;galleryname=$gallery&amp;filetoset=$linksafe_image&amp;kickmeto=".urlencode($currentURL)."' title='edit caption' $target>
                          <img src='$templateImages/caption.png' border='0' /></a>&nbsp;&nbsp;&nbsp;</a>
                          <a $ajaxifydelete href='admin/index.php?action=deleteimage&amp;galleryname=$gallery&amp;filetodelete=$linksafe_image&amp;kickmeto=".urlencode($currentURLdelete)."' title='delete $originalImage' $target>
                          <img src='$templateImages/delete.png' border='0' alt='' /></a></div>";
                }

		$displayDescriptionMeta=1;

	//otherwise we must be an image
	}else{
		$imagedimensions = getimagesize($galleriesRoot.$gallery."/".$image);
		$currentImageName=$image; //This is made available for the template

		if( ($imagedimensions[0] > $imagesdisplaywidth) && ($imagedimensions[0] > $imagedimensions[1]) ){
		    //We dont want people to us all our bandwidth pulling huge images. If its above our limits resize it
		    //and show the resized image. Since high traffic sites might be bogged down by this option, it can
		    //be disbaled in config.php
		    if($enableOnTheFlyResizing){
		        if(!(file_exists($galleriesRoot.$gallery."/lowres_".$image))){
			    if(strtolower(substr($image, (strlen($image)-3), 3)) == 'jpg'){
			        resizeJPG($galleriesRoot.$gallery."/".$image, $galleriesRoot.$gallery."/lowres_".$image,
					$imagesdisplaywidth, '0');
				@chmod($galleriesRoot.$gallery."/lowres_".$image, $chmodPermissions);
                            }else if(strtolower(substr($image, (strlen($image)-4), 4)) == 'jpeg'){
                                resizeJPG($galleriesRoot.$gallery."/".$image, $galleriesRoot.$gallery."/lowres_".$image,
                                        $imagesdisplaywidth, '0');
				@chmod($galleriesRoot.$gallery."/lowres_".$image, $chmodPermissions);
			    }else if(strtolower(substr($image, (strlen($image)-3), 3)) == 'png'){
			        resizePNG($galleriesRoot.$gallery."/".$image, $galleriesRoot.$gallery."/lowres_".$image,
                                        $imagesdisplaywidth, '0');
				@chmod($galleriesRoot.$gallery."/lowres_".$image, $chmodPermissions);
			    }else if(strtolower(substr($image, (strlen($image)-3), 3)) == 'gif'){
			        resizeGIF($galleriesRoot.$gallery."/".$image, $galleriesRoot.$gallery."/lowres_".$image,
                                        $imagesdisplaywidth, '0');
				@chmod($galleriesRoot.$gallery."/lowres_".$image, $chmodPermissions);
			    }

		        }
		    }
		    $originalImage=$image;
                    $image="lowres_".$image;
                    $highres=1;
		}else if( ($imagedimensions[1] > $imagesdisplayheight) && $imagedimensions[1] > $imagedimensions[0] ){
                    //We dont want people to us all our bandwidth pulling huge images. If its above our limite resize it
                    //and show the resized image.
		    if($enableOnTheFlyResizing){
                        if(!(file_exists($galleriesRoot.$gallery."/lowres_".$image))){
			    if(strtolower(substr($image, (strlen($image)-3), 3)) == 'jpg'){
                                resizeJPG($galleriesRoot.$gallery."/".$image, $galleriesRoot.$gallery."/lowres_".$image,
                                        '0', $imagesdisplayheight);
				@chmod($galleriesRoot.$gallery."/lowres_".$image, $chmodPermissions);
                            }else if(strtolower(substr($image, (strlen($image)-4), 4)) == 'jpeg'){
                                resizeJPG($galleriesRoot.$gallery."/".$image, $galleriesRoot.$gallery."/lowres_".$image,
                                        '0', $imagesdisplayheight);
				@chmod($galleriesRoot.$gallery."/lowres_".$image, $chmodPermissions);
			    }else if(strtolower(substr($image, (strlen($image)-3), 3)) == 'png'){
                                resizePNG($galleriesRoot.$gallery."/".$image, $galleriesRoot.$gallery."/lowres_".$image,
                                        '0', $imagesdisplayheight);
				@chmod($galleriesRoot.$gallery."/lowres_".$image, $chmodPermissions);
			    }else if(strtolower(substr($image, (strlen($image)-3), 3)) == 'gif'){
                                resizeGIF($galleriesRoot.$gallery."/".$image, $galleriesRoot.$gallery."/lowres_".$image,
                                        '0', $imagesdisplayheight);
				@chmod($galleriesRoot.$gallery."/lowres_".$image, $chmodPermissions);
			    }
			}
                    }
		    $originalImage=$image;
                    $image="lowres_".$image;
                    $highres=1;
                } else {
		    $originalImage=$image;
		}
		
                if($protect_image_path || $concealPath){
                        $body_content_temp.="<img alt='{$image}' class='viewedImage {$loginViewedImageMod}' src='view.php/".$gallery."/".$image."' $imagesize />";
                }else{
                        $body_content_temp.="<img alt='{$image}' class='viewedImage {$loginViewedImageMod}' src='{$galleriesRoot}{$gallery}/{$image}' $imagesize />";
                }

		if(can_edit($gallery, $_SESSION['s_userName'])){
                    $currentURLdelete=str_replace("a=vi", "a=vg", $currentURL);

                    $body_content_temp.="<div class='adminOptions-vi'>
                          <a $ajaxifycaption href='admin/index.php?action=setcaption&amp;galleryname=$gallery&amp;filetoset=$linksafe_image&amp;kickmeto=".urlencode($currentURL)."' title='edit caption' $target>
                          <img src='$templateImages/caption.png' border='0' /></a>&nbsp;&nbsp;&nbsp;
                          <a $ajaxifythumb href='admin/index.php?action=setthumb&amp;galleryname=$gallery&amp;filetoset=$linksafe_image&amp;kickmeto=".urlencode($currentURL)."' title='make $originalImage master thumbnail' $target>
                          <img src='$templateImages/makethumb.png' border='0' /></a>&nbsp;&nbsp;&nbsp;
                          <a $ajaxifydelete href='admin/index.php?action=deleteimage&amp;galleryname=$gallery&amp;filetodelete=$linksafe_image&amp;kickmeto=".urlencode($currentURLdelete)."' title='delete $originalImage' $target>
                          <img src='$templateImages/delete.png' border='0' alt='' /></a></div>";
                }

		$displayDescriptionMeta=1;
	}

	//store loop var body content
	$loopvars->set_var("body_content", $body_content_temp);
	unset($body_content_temp); 

        if(file_exists($galleriesRoot.$gallery."/".$originalImage.".php")){
                include $galleriesRoot.$gallery."/".$originalImage.".php";
        }

	//store loop var image caption                  
        if(trim($imageDetails[0])!=""){
		$loopvars->set_var("image_caption", $imageDetails[0]);
        }

	//store loop var gallery copyright
        if($galleryCopyright!=''){
		$loopvars->set_var("gallery_copyright", $galleryCopyright);
        }
        
	//store loop var download path
        if(!is_movie($image) && $currentImageName!='' && ($downloadLink=='1' || $downloadLink=='2')){
                if($highres && $downloadLink=='2'){
			$loopvars->set_var("image_hires", true);
			$loopvars->set_var("image_download_path", "download.php/".$gallery."/".$originalImage);
                }else{
			$loopvars->set_var("image_hires", false);
			$loopvars->set_var("image_download_path", "download.php/".$gallery."/".$image);
                } 
        }

	/* CALL THEME HEADER */
        include $themeName."/overall_header.php";
                
	//check for get_head() call        
        if(!$loopvars->get_var("get_head")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_head().
                     </div>");
        }

	//check for get_body() call -- for legacy support automatically spit out content if no call is made by footer. 
	//This will be dropped by 4.0
        if(!$loopvars->get_var("get_content")){
		$loopvars->echo_var("body_content");              
	}


	/* CALL THEME FOOTER */
	include $themeName."/overall_footer.php";

	//check for get_footer() call
	if(!$loopvars->get_var("get_footer")){    
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_footer().
                     </div>");
        }

	break;

  case 'vg':
  	/* VIEW GALLERY
	   this is what spits out the images within the requested gallery
	*/

	if(!file_exists($galleriesRoot.$gallery)) {
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']));
	}

	//get gallery details
	$galleryInfo=get_gallery_details($galleriesRoot.$gallery);
	$posterID=$galleryInfo[0];
	$datePosted=$galleryInfo[1];
	$title=$galleryInfo[2];
	$description=$galleryInfo[3];
	$sortOrder=$galleryInfo[4];
	$downloadLink=$galleryInfo[5];
	$galleryCopyright=$galleryInfo[6];
	$concealPath=$galleryInfo[7];

	if($sortOrder=="" || !$sortOrder){
	    $sortOrder=$defaultImageSortOrder;
	}

        //users would probably prefer the default sort order so when visiting off the main gallery we user $r for reset
        if($r==1){
	    $galleryViewSortOrder=$sortOrder;
            $_SESSION['s_galleryViewSortOrder']=$sortOrder;
        }

	if(!$currentpage)
	    $currentpage=1;

        /* GET THE DIRECTORY LISTING OF THE GALLERIES DIRECTORY. EACH GALLERY IS IN ITS OWN
           DIRECTORY. IF WE ARE DISPLAYING PERSONAL GALLERIES WE NEED TO TAKE ONE ADDITIONAL STEP
           AND CHECK DIRNAME FORREQUESTED USERS PERSONAL GALLERY STRING.
        */
        $clsDirListingDefault = new clsDirListing($galleriesRoot.$gallery, 0);
        $clsDirListingDefault->sortOrder($galleryViewSortOrder);
	$clsDirListingDefault->extensionIncludes(array("jpg", "gif", "png", "avi", "mpg", "mpeg", "mov", "wmv", "jpeg", "mp4", "flv"));
	$clsDirListingDefault->prefixExcludes(array("thm_", "lowres_"));
        $images=$clsDirListingDefault->getListing();
        $clsDirListingDefault="";

	$maximagesperpage=$numImageColumns*$numImageRows;
	$gallerycount=($currentpage-1)*$maximagesperpage;

        $pages=intval((count($images)-1) / $maximagesperpage);
        if($pages < ((count($images)) / $maximagesperpage)){
                $extrapage=1;
        } else {
                $extrapage=0;
        }
        $totalpages=$pages+$extrapage;

  	//<!-- figure out how many pages we need -->
	if($currentpage>1){
  		$prevtemp=($gallerycount-$maximagesperpage);
  		$linkpage=$currentpage-1;
                $previouspage="<a href='$pageFileName?cp={$linkpage}&amp;a=vg&amp;g={$gallery}{$appendPG1}{$appendGP}' $target>&lt;</a>";

  	}

	if($totalpages>$currentpage){
  		$nexttemp=($gallerycount+$maximagesperpage);
  		$linkpage=$currentpage+1;
                $nextpage="<a href='$pageFileName?cp={$linkpage}&amp;a=vg&amp;g={$gallery}{$appendPG1}{$appendGP}' $target>&gt;</a>";

  	}

	//Work out page breaks. We dont want to overload our users with every page in the gallery...
	$PREpageoutstring="";
	$POSTpageoutstring="";
        if(intval($currentpage) < 10){ //Were in the first 10 pages
                $startPage=1;
                $endPage=10;

                if($totalpages<$endPage){
                       $endPage=$totalpages;
                }

		if($totalpages!=$endPage){
                        $POSTpageoutstring="&nbsp;<b>...</b>&nbsp;<a href='$pageFileName?cp={$totalpages}&amp;a=vg&amp;g={$gallery}{$appendPG1}{$appendGP}' $target>$totalpages</a>";
                }
        }else{
		if(intval(substr($currentpage, strlen($currentpage)-1, 1))==0){ //were past the first 10 pages and its a "milestone"
			$startPage=intval($currentpage)-1;
			$endPage=intval($currentpage)+10;

			if($totalpages<$endPage){
				$endPage=$totalpages;
				$POSTpageoutstring="";
			}

			$PREpageoutstring="<a href='$pageFileName?cp=1&amp;a=vg&amp;g={$gallery}{$appendPG1}{$appendGP}' $target>1</a>&nbsp;&nbsp;<b>...</b>&nbsp;";
                        if($totalpages!=$endPage){
                                $POSTpageoutstring="&nbsp;<b>...</b>&nbsp;&nbsp;<a href='$pageFileName?cp={$totalpages}&amp;a=vg&amp;g={$gallery}{$appendPG1}{$appendGP}' $target>$totalpages</a>";
                        }
		}else{ //were past the first 10 pages but its not a "milestone"
			$tempPageCalc=$currentpage;
			$tempPageCalc=substr_replace($currentpage, 0, strlen($currentpage)-1, 1);
			$startPage=$tempPageCalc-1;
                        $endPage=$tempPageCalc+10;

	                if($totalpages<$endPage){
	                        $endPage=$totalpages;
				$POSTpageoutstring="";
	                }

			$PREpageoutstring="<a href='$pageFileName?cp=1&amp;a=vg&amp;g={$gallery}{$appendPG1}{$appendGP}' $target>1</a>&nbsp;&nbsp;<b>...</b>&nbsp;";
                        if($totalpages!=$endPage){
                                $POSTpageoutstring="&nbsp;<b>...</b>&nbsp;&nbsp;<a href='$pageFileName?cp={$totalpages}&amp;a=vg&amp;g={$gallery}{$appendPG1}{$appendGP}' $target>$totalpages</a>";
                        }
		}
	}

        $pageoutstringA=$PREpageoutstring;
  	//compile extra page links
  	for($z=$startPage; $z < $endPage+1; $z++){
  		$tempcount=(($z*$maximagesperpage)-$maximagesperpage);

		if($z==$currentpage){
		    $curpagemarker1='  [&nbsp;';
		    $curpagemarker2='&nbsp;]';
		}else{
		    $curpagemarker1='';
		    $curpagemarker2='';
		}

		if($totalpages!=1)
                   $pageoutstringA.=" <a href='$pageFileName?cp={$z}&amp;a=vg&amp;g={$gallery}{$appendPG1}{$appendGP}' $target>$curpagemarker1$z$curpagemarker2</a>&nbsp;";
  	}
	$pageoutstringA.=$POSTpageoutstring;

	if(can_edit($gallery, $_SESSION['s_userName'])){
                $templateUpload="<a title='upload images' $ajaxifyupload href='admin/index.php?action=uploadimages&amp;galleryname={$gallery}&cms={$cms}'><img src='{$themeName}/images/ingal_uploadImages.gif' border='0' /></a>";
		$templateEditGallery="<a title='edit gallery properties' $ajaxifynewgallery href='admin/index.php?action=editgallerydetails&amp;galleryname={$gallery}&cms={$cms}'><img src='{$themeName}/images/ingal_editGallery.gif' border=0 /></a>";
		$templateDeleteGallery="<a title='delete gallery' $ajaxifydelete href='admin/index.php?action=deletegallery&amp;galleryname={$gallery}&cms={$cms}'><img src='{$themeName}/images/ingal_deleteGallery.gif' border=0 /></a>";
	}else{
		$templateUpload="";
		$templateEditGallery="";
		$templateDeleteGallery="";
	}

	$templateSortBy="<form method='post' action='index.php?a=$a&amp;g={$gallery}&amp;q=$searchTerm' enctype='multipart/form-data' class='sortForm'><input type='hidden' name='cms' value='{$cms}' /><select name='galleryViewSortOrder' class='sortForm' onChange='this.parentNode.submit();'>";
        if($_SESSION['s_galleryViewSortOrder']=='dateDESC'){
	        $templateSortBy.="<option value='dateDESC' SELECTED>Newest to Oldest</option>";
        }else{
                $templateSortBy.="<option value='dateDESC'>Newest to Oldest</option>";
        }
        if($_SESSION['s_galleryViewSortOrder']=='dateASC'){
                $templateSortBy.="<option value='dateASC' SELECTED>Oldest to Newest</option>";
        }else{
                $templateSortBy.="<option value='dateASC'>Oldest to Newest</option>";
        }
        if($_SESSION['s_galleryViewSortOrder']=='titleAlphabetical'){
                $templateSortBy.="<option value='titleAlphabetical' SELECTED>Image Title</option>";
        }else{
                $templateSortBy.="<option value='titleAlphabetical'>Image Title</option>";
        }
        $templateSortBy.="</select>&nbsp;<input type='submit' value='go' class='sortFormButton' /></form>";
	$loopvars->set_var("sort_form", $templateSortBy);

	$body_content_temp="";

  	/* DISPLAY IMAGES IN A TABLE. CLASS EACH TABLE. ALLOW SPACING (SET IN CONFIG.PHP) FOR TILES
           THEMES WILL LOVE US FOR THIS
        */
  	if($images && ($gallerycount < (count($images)))){

  		$body_content_temp.="<table class='imageTiles' width='{$primaryGalleryWidth}' cellspacing='{$imageTilesSpacing}'>\n";

		$intColumnCount=1;
  		for($y = $gallerycount; $y < ($gallerycount+$maximagesperpage); $y++){

		    if(!isset($images[$y]))
      			break; // break out of loop

  		    //first column of images
  		    $v_images=$images[$y][0];

            //encoded image name for links
            $linksafe_image=urlencode(htmlentities($images[$y][0], ENT_QUOTES));

			if($intColumnCount==1)
				$body_content_temp.="<tr>";

			/* IF ENABLED THE GALLERY WILL CHECK FOR THUMBNAIL EXISTANCE EVERYTIME AN IMAGE IS ENCOUNTERED.
			   IF NO THUMB EXISTS ONE WILL BE CREATED. THIS ALLOWS FILE UPLOAD VIA FTP WHILE MAINTAINING AUTOMATIC
			   THUMNAIL CREATION. DISABLED BY DEFAULT BECAUSE WHEN THE FLASH UPLOADER IS USED THE RESIZING AND
			   THUMNAIL CREATION ARE HANDLED BY OUR UPLOAD SCRIPT.
			*/
			if($enableOnTheFlyResizing){
			    $imagedimensions = getimagesize($galleriesRoot.$gallery."/".$v_images);

  			    if(strtolower(substr($v_images, (strlen($v_images)-3), 3)) == 'jpg') {
				if(!(file_exists($galleriesRoot.$gallery."/thm_".$v_images))){
					set_time_limit(30);

					if($imagedimensions[0] > $imagedimensions[1]){
					    resizeJPG($galleriesRoot.$gallery."/".$v_images, $galleriesRoot.$gallery."/thm_".$v_images, $thmimagewidth,
							'0');
					    @chmod($galleriesRoot.$gallery."/thm_".$v_images, $chmodPermissions);
					}else{
                                            resizeJPG($galleriesRoot.$gallery."/".$v_images, $galleriesRoot.$gallery."/thm_".$v_images, '0',
							$thmimageheight);
					    @chmod($galleriesRoot.$gallery."/thm_".$v_images, $chmodPermissions);
					}
  				}
                            }else if(strtolower(substr($v_images, (strlen($v_images)-4), 4)) == 'jpeg') {
                                if(!(file_exists($galleriesRoot.$gallery."/thm_".$v_images))){
                                        set_time_limit(30);

                                        if($imagedimensions[0] > $imagedimensions[1]){
                                            resizeJPG($galleriesRoot.$gallery."/".$v_images, $galleriesRoot.$gallery."/thm_".$v_images, $thmimagewidth,
                                                        '0');
					    @chmod($galleriesRoot.$gallery."/thm_".$v_images, $chmodPermissions);
                                        }else{
                                            resizeJPG($galleriesRoot.$gallery."/".$v_images, $galleriesRoot.$gallery."/thm_".$v_images, '0',
                                                        $thmimageheight);
					    @chmod($galleriesRoot.$gallery."/thm_".$v_images, $chmodPermissions);
                                        }
                                }
  			    } else if (strtolower(substr($v_images, (strlen($v_images)-3), 3)) == 'png'){
  				if(!(file_exists($galleriesRoot.$gallery."/thm_".$v_images))){
					set_time_limit(30);

                                        if($imagedimensions[0] > $imagedimensions[1]){
                                            resizePNG($galleriesRoot.$gallery."/".$v_images, $galleriesRoot.$gallery."/thm_".$v_images, $thmimagewidth,
                                                        '0');
					    @chmod($galleriesRoot.$gallery."/thm_".$v_images, $chmodPermissions);
                                        }else{
                                            resizePNG($galleriesRoot.$gallery."/".$v_images, $galleriesRoot.$gallery."/thm_".$v_images, '0',
                                                        $thmimageheight);
					    @chmod($galleriesRoot.$gallery."/thm_".$v_images, $chmodPermissions);
                                        }
  				}
  			    } else if (strtolower(substr($v_images, (strlen($v_images)-3), 3)) == 'gif'){
  				if(!(file_exists($galleriesRoot.$gallery."/thm_".$v_images))){
					set_time_limit(30);

                                        if($imagedimensions[0] > $imagedimensions[1]){
                                            resizeGIF($galleriesRoot.$gallery."/".$v_images, $galleriesRoot.$gallery."/thm_".$v_images,
							$thmimagewidth, '0');
					    @chmod($galleriesRoot.$gallery."/thm_".$v_images, $chmodPermissions);
                                        }else{
                                            resizeGIF($galleriesRoot.$gallery."/".$v_images, $galleriesRoot.$gallery."/thm_".$v_images, '0',
                                                        $thmimageheight);
					    @chmod($galleriesRoot.$gallery."/thm_".$v_images, $chmodPermissions);
                                        }
  				}
			    }
			}

			/* CHECK FOR IMAGE OR MOVIE TYPE AND DISPLAY THE APPROPRIATE THUMBNAIL. ALSO SPIT OUT THE CELL AND
			   LINK.
			*/
			$imageExtension=strtolower(substr($v_images, (strlen($v_images)-3), 3));
			if ($imageExtension=='gif' || $imageExtension=='jpg' || strtolower(substr($v_images, (strlen($v_images)-4), 4))=='jpeg'||$imageExtension=='png'){

				$body_content_temp.="<td class='imageTiles'>";

				if($protect_image_path || $concealPath){
					$body_content_temp.="<a href='$pageFileName?a=vi&amp;g={$gallery}&amp;i=$linksafe_image&amp;cp={$currentpage}{$appendPG1}{$appendGP}' $target><img alt='$v_images' border='0' src='view.php/".$gallery."/thm_".$v_images."' class='imageTiles' />$imgNameHTMLCommentOpen<br/>".$v_images."$imgNameHTMLCommentClose</a>";
				}else{
					$body_content_temp.="<a href='$pageFileName?a=vi&amp;g={$gallery}&amp;i=$linksafe_image&amp;cp={$currentpage}{$appendPG1}{$appendGP}' $target><img alt='$v_images' border='0' src='".$galleriesRoot.$gallery."/thm_".$v_images."'class='imageTiles' /></a>";
				}

				if(can_edit($gallery, $_SESSION['s_userName'])){
                                        $body_content_temp.="<br/><div class='adminOptions'><a $ajaxifycaptionNoRefresh href='admin/index.php?action=setcaption&amp;galleryname=$gallery&amp;filetoset=$linksafe_image&amp;kickmeto=".urlencode($currentURL)."' title='edit caption' $target>
                                              <img src='$templateImages/caption.png' border='0' /></a>&nbsp;&nbsp;&nbsp;
					      <a $ajaxifythumb href='admin/index.php?action=setthumb&amp;galleryname=$gallery&amp;filetoset=$linksafe_image&amp;kickmeto=".urlencode($currentURL)."' title='make $linksafe_image master thumbnail' $target>
                                              <img src='$templateImages/makethumb.png' border='0' /></a>&nbsp;&nbsp;&nbsp;
                                              <a $ajaxifydelete href='admin/index.php?action=deleteimage&amp;galleryname=$gallery&amp;filetodelete=$linksafe_image&amp;kickmeto=".urlencode($currentURL)."' title='delete $v_images' $target>
                                              <img src='$templateImages/delete.png' border='0' alt='' /></a></div>";
                                }

                                $body_content_temp.="</td>\n";

			//Display Movie Tiles
			} else if(is_movie($v_images)){

				$body_content_temp.="<td class='imageTiles'><div style='position: relative; height: 100%; width: 100%;'> ";

                                $body_content_temp.="<a href='$pageFileName?a=vi&amp;g={$gallery}&amp;i=$linksafe_image&amp;cp={$currentpage}{$appendPG1}{$appendGP}' $target style='padding: 0; margin: 0;'><img src='{$themeName}/images/playMovie.png' border='0' class='imageTiles' alt='$v_images' /></a>";
                                $body_content_temp.="<div class='videoTitle'><a href='$pageFileName?a=vi&amp;g={$gallery}&amp;i=$linksafe_image&amp;cp={$currentpage}{$appendPG1}{$appendGP}' $target >$v_images</a></div>";

                                if(can_edit($gallery, $_SESSION['s_userName'])){
                                        $body_content_temp.="<br/><div class='adminOptions'><a $ajaxifycaptionNoRefresh href='admin/index.php?action=setcaption&amp;galleryname=$gallery&amp;filetoset=$linksafe_image&amp;kickmeto=".urlencode($currentURL)."' title='edit caption' $target>
                                              <img src='$templateImages/caption.png' border='0' /></a>&nbsp;&nbsp;&nbsp;
                                              <a $ajaxifydelete href='admin/index.php?action=deleteimage&amp;galleryname=$gallery&amp;filetodelete=$linksafe_image&amp;kickmeto=".urlencode($currentURL)."' title='delete $v_images' $target>
                                              <img src='$templateImages/delete.png' border='0' alt='' /></a></div>";
                                }
                                
                                $body_content_temp.="</div></td>\n";			
			}

			/* IF THIS IS THE END OF THE ROW THEN ITS TIME TO END THIS ROW AND FLAG FOR NEW ROW.
			   IF WERE OUT OF IMAGES THEN BREAK LOOP
			*/
			if($intColumnCount==$numImageColumns){
			    $body_content_temp.="</tr>";
			    $intColumnCount=1;
			}else{
  			    //check for a break again
  			    if(($y) == (count($images)-1)){
  			         for($colouttage=$intColumnCount; $colouttage<$numImageColumns; $colouttage++){
  				     $body_content_temp.="<td></td>";
  			         }
  			         $body_content_temp.="</tr>";
  			    }
			    $intColumnCount++;
  			}
  		}

  		$body_content_temp.="</table>";

  	} else {
  		//there are no galleries so exit gracefully
		$body_content_temp.="<br/><br/><br/><span class='status'>There are currently no images in this gallery.</span><br/><br/><br/><br/>\n";
	}

	//store loop var body content
        $loopvars->set_var("body_content", $body_content_temp);
        unset($body_content_temp);

	/* THEME HEADER */
        include $themeName."/overall_header.php";
        
        if(!$loopvars->get_var("get_head")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_head().
                     </div>");
        }

	//check for get_body() call -- for legacy support automatically spit out content if no call is made by footer.
        //This will be dropped by 4.0
        if(!$loopvars->get_var("get_content")){
                $loopvars->echo_var("body_content");
        }

	/* THEME FOOTER */
	include $themeName."/overall_footer.php";

	if(!$loopvars->get_var("get_footer")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_footer().
                     </div>");
        }

  	//<!-- end gallery choices and page links-->
	break;

  case 'reg':
	if(isset($_SESSION['s_userName'])){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']));
		break;
	}

	/* USER REGISTRATION
	   allows user to register with gallery
	*/

	$requestedUsername='';
	$requestedPassword='';
	$userEmailAddress='';
	$usersFirstName='';
	$usersLastName='';
	$error='';

	if(isset($_GET['requestedUsername']))
		$requestedUsername=strtolower(trim($_GET['requestedUsername']));

        if(isset($_GET['requestedPassword']))
                $requestedPassword=strtolower(trim($_GET['requestedPassword']));

	if(isset($_GET['userEmailAddress']))
		$userEmailAddress=$_GET['userEmailAddress'];

	if(isset($_GET['usersFirstName']))
		$usersFirstName=$_GET['usersFirstName'];

	if(isset($_GET['usersLastName']))
		$usersLastName=$_GET['usersLastName'];

	if(isset($_GET['error']))
		$error=$_GET['error'];

	$body_content_temp="";

	$body_content_temp.="<table width='100%'><tr><td align='left' class='status'><b>New User Registration</b></td></tr></table>";

        if(!$allowUserRegistration){
            die("Functionality disabled by administrator.");
        }

	if($error=="success"){
	$body_content_temp.="<table><tr><td align='left' class='registration'>
	      You have registered with the following information.
	      <br/>
	      <br/>Username: <b>$requestedUsername</b>
	      <br/>Password: <b>$requestedPassword</b>
	      <br/>
	      <br/>Please record this information for future use.
	      </td></tr></table>";

	}else{
	switch($error){
	    case 'userTaken':
		$body_content_temp.="<span class='registrationError'>ERROR: The username you requested is not available.</span><br/><br/><br/>";
		break;

	    case 'passMissMatch':
		$body_content_temp.="<span class='registrationError'>ERROR: The passwords you entered did not match.</span><br/><br/><br/>";
                break;

            case 'passChar':
		$body_content_temp.="<span class='registrationError'>ERROR: Your password contained illegal characters. Passwords may only be alphanumeric.</span><br/><br/><br/>";
                break;

	    case 'fieldBlank':
                $body_content_temp.="<span class='registrationError'>ERROR: You left a field blank. ALL fields are mandatory.</span><br/><br/><br/>";
                break;

	    case 'codeMismatch':
                $body_content_temp.="<span class='registrationError'>ERROR: The verification code you entered was not correct.</span><br/><br/><br/>";
                break;
	}

	$body_content_temp.="<table><tr><td align='left' class='registration'><form method='post' action='userswrite.php'>
		<input type='hidden' name='cms' value='{$cms}' />
		<input type='hidden' name='action' value='reg' />
		*All fields are required<br/><br/>
		Desired Username: <input type='text' name='requestedUsername' value='{$requestedUsername}' /><br/>
		<br/>
		Desired Password: <input type='password' name='requestedPassword' /><br/>
		Re-enter Password: <input type='password' name='requestedPassword2' /><br/>
		<br/>
		First Name: <input type='text' name='usersFirstName' value='{$usersFirstName}' /><br/>
		Last Name: <input type='text' name='usersLastName' value='{$usersLastName}' /><br/>
		Email Address: <input type='text' name='usersEmailAddress' value='{$userEmailAddress}' /> (not published)<br/><br/>";


	$body_content_temp.="<center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		<img src='captcha.php' /></center>";

	$body_content_temp.="Please enter the verification code above: <input type='text' name='response' />
		<br/>
		<br/>User Agreement:<br/>
		<textarea rows='10' cols='50'>";

	$body_content_temp.=file_get_contents('./useragreement.txt');

	$body_content_temp.="</textarea>
		<br/>
		<br/><center><input type='submit' value='Register' class='registrationButton' /></center>
	      </form></td></tr></table>";
	}

	//store loop var body content
        $loopvars->set_var("body_content", $body_content_temp);
	unset($body_content_temp); 

        /* THEME HEADER */
        include $themeName."/overall_header.php";
        
        if(!$loopvars->get_var("get_head")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_head().
                     </div>");
        }

	//check for get_body() call -- for legacy support automatically spit out content if no call is made by footer.
        //This will be dropped by 4.0
        if(!$loopvars->get_var("get_content")){
                $loopvars->echo_var("body_content");
        }

	/* THEME FOOTER */
        include $themeName."/overall_footer.php";

	if(!$loopvars->get_var("get_footer")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_footer().
                     </div>");
        }

	break;

  case 'pr':
	/* PASSWORD RECOVERY
	   user inputs password and will receive an email with new pass (when encrypted) and old pass when not
	*/

	require('users/users.inc.php'); //INCLUDE OUT USERS FILE

	$retrievedUsername='';
	$retrievedPassword='';
	$retrievedFirstName='';

	$body_content_temp="";
	
	$body_content_temp.="<table width='100%'><tr><td align='left' class='status'><b>Lost Password Retrieval</b></td></tr></table>";

	if(isset($_POST['userEmailAddress'])){
		/* LOOP THROUGH USERS UNTIL WE FIND THE EMAIL ADDRESS IT WAS REGISTER UNDER. tHEN STORE THIS DATA FOR EMAIL */
		foreach($users as $tmp_users){
		    if(strtolower(trim($tmp_users[2]))==strtolower(trim($_POST['userEmailAddress']))){
			$retrievedUsername=$tmp_users[0];
			$retrievedPassword=$tmp_users[1];
			$retrievedFirstName=$tmp_users[3];
			break;
		    }
		}

		/* IF WE FOUND THE EMAIL THEN THE PASSWORD WONT BE BLANK. NOW EMAIL
		   THE USER THEIR INFO WITH GOOD MESSAGE STRUCTURE. iF NO PASS WAS FOUND THEN THE USER DIDNT EXIST
		   SO REDIRECT WITH THIS ERROR CODE.
		*/
		if($retrievedPassword!=''){

                $mail_to=strtolower(trim($_POST['userEmailAddress']));
                $subject=$galleryTitle." - Account Information";
                $body="Dear $retrievedFirstName,\n\nYour account information is as follows.\n\nUsername: $retrievedUsername\nPassword: $retrievedPassword";

                $eol="\r\n";
                $headers .= 'From: '.$passwordRetrievalEmail.$eol;
                $headers .= 'Reply-To: '.$passwordRetrievalEmail.$eol;
                $headers .= 'Return-Path: '.$passwordRetrievalEmail.$eol;    // these two to set reply address
                $headers .= "Message-ID: <".$now.$passwordRetrievalEmail.">".$eol;
                $headers .= "X-Mailer: PHP/".phpversion().$eol;
                $mime_boundary=md5(time());
                $headers .= 'MIME-Version: 1.0'.$eol;
		$headers .= "Content-type: text/plain; charset=UTF-8".$eol;

                mail($mail_to, $subject, $body, $headers);

		      $body_content_temp.="<br/><br/><table><tr><td align='left' class='registration'>
		      Your account information has been sent to {$_POST['userEmailAddress']} from $passwordRetrievalEmail.
		      <br/>Please add $passwordRetrievalEmail to your address book to prevent this email from being flagged as spam.
		      </td></tr></table><br/><br/><br/>";
		}else{
	              $body_content_temp.="<br/><br/><table><tr><td align='left' class='registration'>
        	      <form method='post' action='index.php?a=pr' style='padding: 0; margin: 0;'><input type='hidden' name='cms' value='{$cms}' />
              	      Enter email address used to register: <input type='text' name='userEmailAddress' style='width:180px;'> <input type='submit' value='Retrieve Password' class='registrationButton'>
              	      </form>
              	      </td></tr></table><br/><br/><br/>";
		}
	}else{
	      $body_content_temp.="<br/><br/><table><tr><td align='left' class='registration'>
	      <form method='post' action='index.php?a=pr' style='padding: 0; margin: 0;'><input type='hidden' name='cms' value='{$cms}' />
	      Enter email address used to register: <input type='text' name='userEmailAddress' style='width:180px;'> <input type='submit' value='Retrieve Password' class='registrationButton'>
	      </form>
	      </td></tr></table><br/><br/><br/>";
	}
	
	//store loop var body content
        $loopvars->set_var("body_content", $body_content_temp);
	unset($body_content_temp); 
        
        /* THEME HEADER */
        include $themeName."/overall_header.php";
        
        if(!$loopvars->get_var("get_head")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_head().
                     </div>");
        }

	//check for get_body() call -- for legacy support automatically spit out content if no call is made by footer.
        //This will be dropped by 4.0
        if(!$loopvars->get_var("get_content")){
                $loopvars->echo_var("body_content");
        }

	/* THEME FOOTER */
        include $themeName."/overall_footer.php";

	if(!$loopvars->get_var("get_footer")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_footer().
                     </div>");
        }

        break;

  case 'chgpass':

        if(isset($_GET['error']))
                $error=$_GET['error'];

        if(!isset($_SESSION['s_userName'])){
                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']));
                break;
        }

	$body_content_temp="";

        $body_content_temp.="<table width='100%'><tr><td align='left' class='status'><b>Change Password</b></td></tr></table>";

        if($error=="success"){
		$body_content_temp.="<br/><br/><span class='registrationSuccess'>Success: Your password has been changed.</span><br/><br/><br/>";
        }else{
	        switch($error){
	            case 'wrongpass':
	                $body_content_temp.="<br/><br/><span class='registrationError'>ERROR: The current password you entered was incorrect.</span><br/>";
	                break;

	            case 'passMissMatch':
	                $body_content_temp.="<br/><br/><span class='registrationError'>ERROR: The passwords you entered did not match.</span><br/>";
	                break;

                    case 'passChar':
                        $body_content_temp.="<br/><br/><span class='registrationError'>ERROR: The password you entered contained illegal characters. Passwords may only be alphanumeric.</span><br/>";
                        break;

	            case 'fieldBlank':
	                $body_content_temp.="<br/><br/><span class='registrationError'>ERROR: You left a field blank. ALL fields are mandatory.</span><br/>";
	                break;
	        }

	        $body_content_temp.="<br/><table><tr><td align='left' class='registration'><form method='post' action='userswrite.php'>
		<input type='hidden' name='cms' value='{$cms}' />
                <input type='hidden' name='action' value='chgpass' />
		*Please complete ALL fields
                <br/><br/>Current Password: <input type='password' name='currentPassword' value='' /><br/>
                <br/>
                New Password: <input type='password' name='requestedPassword' /><br/>
                Re-enter New Password: <input type='password' name='requestedPassword2' /><br/>
		<br/><center><input type='submit' value='Change Password' /></center>
                </form></td></tr></table><br/><br/>";
        }

	//store loop var body content
        $loopvars->set_var("body_content", $body_content_temp);
	unset($body_content_temp); 
        
        /* THEME HEADER */
        include $themeName."/overall_header.php";
                
        if(!$loopvars->get_var("get_head")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_head().
                     </div>");
        }

	//check for get_body() call -- for legacy support automatically spit out content if no call is made by footer.
        //This will be dropped by 4.0
        if(!$loopvars->get_var("get_content")){
                $loopvars->echo_var("body_content");
        }

        /* THEME FOOTER */
        include $themeName."/overall_footer.php";

	if(!$loopvars->get_var("get_footer")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_footer().
                     </div>");
        }

        break;

  case 's':
	/* DISPLAY GALLERIES
	   the default action is to list all galleries (or virtual personal galleries if requested)
	*/
	if(!$gp){
		$gp=1;
	}


	/*
	Create a new directory listing instance and process directory listing for master gallery images
	*/
	$clsDirListingDefault = new clsDirListing($galleriesRoot, 6);
	$clsDirListingDefault->sortOrder($galleryListingSortOrder);
	$clsDirListingDefault->includes($searchTerm);
	$clsDirListingDefault->excludes(array("logs"));
	$galleries=$clsDirListingDefault->getListing();
	$clsDirListingDefault="";


	$maxgalleriesperpage=$numGalleryColumns*$numGalleryRows;
        $pages=intval((count($galleries)-1) / $maxgalleriesperpage);
        if($pages < ((count($galleries)) / $maxgalleriesperpage)){
                $extrapage=1;
        } else {
                $extrapage=0;
        }
        $totalpages=$pages+$extrapage;

	$gallerycount=($gp-1)*$maxgalleriesperpage;

	/* FIGURE OUT HOW MANY PAGES WERE GOING TO NEED */
	if($gp>1){
		$prevtemp=($gallerycount-$maxgalleriesperpage);
		$linkpage=$gp-1;
                $previouspage="<a href='$pageFileName?a=s&amp;q=$searchTerm&gp={$linkpage}{$appendPG1}' $target>&lt;</a>";
	}

	if($totalpages>$gp){
		$nexttemp=($gallerycount+$maxgalleriesperpage);
		$linkpage=$gp+1;
                $nextpage="<a href='$pageFileName?a=s&amp;q=$searchTerm&gp={$linkpage}{$appendPG1}' $target>&gt;</a>";
	}

	$pages=intval((count($galleries)-1) / $maxgalleriesperpage);
	if($pages < ((count($galleries)) / $maxgalleriesperpage)){
		$extrapage=1;
	} else {
		$extrapage=0;
	}
	$totalpages=$pages+$extrapage;

        //Work out page breaks. We dont want to overload our users with every page in the gallery...
        $PREpageoutstring="";
        $POSTpageoutstring="";
        if(intval($gp) < 10){ //Were in the first 10 pages
                $startPage=1;
                $endPage=12;

                if($totalpages<$endPage){
                       $endPage=$totalpages;
                }

		if($totalpages!=$endPage){
                	$POSTpageoutstring="&nbsp;<b>...</b>&nbsp;<a href='$pageFileName?a=s&amp;q=$searchTerm&gp={$totalpages}{$appendPG1}' $target>$totalpages</a>";
		}
        }else{
                if(intval(substr($gp, strlen($gp)-1, 1))==0){ //were past the first 10 pages and its a "milestone"
                        $startPage=intval($gp)-2;
                        $endPage=intval($gp)+12;

                        if($totalpages<$endPage){
                                $endPage=$totalpages;
                                $POSTpageoutstring="";
                        }

			$PREpageoutstring="<a href='$pageFileName?a=s&amp;q=$searchTerm&gp=1{$appendPG1}' $target>1</a>&nbsp;&nbsp;<b>...</b>&nbsp;";
			if($totalpages!=$endPage){
                        	$POSTpageoutstring="&nbsp;<b>...</b>&nbsp;&nbsp;<a href='$pageFileName?a=s&amp;q=$searchTerm&gp={$totalpages}{$appendPG1}' $target>$totalpages</a>";
			}
                }else{ //were past the first 10 pages but its not a "milestone"
                        $tempPageCalc=$gp;
                        $tempPageCalc=substr_replace($gp, 0, strlen($gp)-1, 1);
                        $startPage=$tempPageCalc-2;
                        $endPage=$tempPageCalc+12;

                        if($totalpages<$endPage){
                                $endPage=$totalpages;
                                $POSTpageoutstring="";
                        }

                        $PREpageoutstring="<a href='$pageFileName?a=s&amp;q=$searchTerm&gp=1{$appendPG1}' $target>1</a>&nbsp;&nbsp;<b>...</b>&nbsp;";
			if($totalpages!=$endPage){
	                        $POSTpageoutstring="&nbsp;<b>...</b>&nbsp;&nbsp;<a href='$pageFileName?a=s&amp;q=$searchTerm&gp={$totalpages}{$appendPG1}' $target>$totalpages</a>";
			}
                }
        }

        $pageoutstringA=$PREpageoutstring;
	/* LOOP THROUGH THE PAGE COUNT AND CREATE THE OUTPUT FOR USE IN OUR THEME FOR THE PAGE LINKS.
	   wE WILL DENOTE THE CURRENT PAGE WITH BRACKETS. IF THE THEME WANTS TO DO SOMETHING DIFFERENT
	   THEY CAN REPLACE THE CHARS.
	*/
        $pageoutstringA=$PREpageoutstring;
        //compile extra page links
        for($z=$startPage; $z < $endPage+1; $z++){
		$tempcount=(($z*$maxgalleriesperpage)-$maxgalleriesperpage);

                if($z==$gp){
                    $curpagemarker1='  [&nbsp;';
                    $curpagemarker2='&nbsp;]';
                }else{
                    $curpagemarker1='';
                    $curpagemarker2='';
                }

		if($totalpages!=1)
		    $pageoutstringA.=" <a href='$pageFileName?a=s&amp;q=$searchTerm&gp={$z}{$appendPG1}' $target>$curpagemarker1$z$curpagemarker2</a>&nbsp;";
	}
	$pageoutstringA.=$POSTpageoutstring;

	$templateSortBy="<form method='post' action='index.php?a=s&amp;q={$searchTerm}' enctype='multipart/form-data' class='sortForm'><input type='hidden' name='cms' value='{$cms}' /><select name='galleryListingSortOrder' class='sortForm' onChange='this.parentNode.submit();'>";
        if($_SESSION['s_galleryListingSortOrder']=='dateDESC'){
		$templateSortBy.="<option value='dateDESC' SELECTED>Newest to Oldest</option>";
        }else{
                $templateSortBy.="<option value='dateDESC'>Newest to Oldest</option>";
        }
        if($_SESSION['s_galleryListingSortOrder']=='dateASC'){
                $templateSortBy.="<option value='dateASC' SELECTED>Oldest to Newest</option>";
        }else{
                $templateSortBy.="<option value='dateASC'>Oldest to Newest</option>";
        }
        if($_SESSION['s_galleryListingSortOrder']=='dateModifiedDESC'){
                $templateSortBy.="<option value='dateModifiedDESC' SELECTED>Recently Modified</option>";
        }else{
                $templateSortBy.="<option value='dateModifiedDESC'>Recently Modified</option>";
        }
        if($_SESSION['s_galleryListingSortOrder']=='titleAlphabetical'){
                $templateSortBy.="<option value='titleAlphabetical' SELECTED>Gallery Title</option>";
        }else{
                $templateSortBy.="<option value='titleAlphabetical'>Gallery Title</option>";
        }
        if(!$pg){
                if($_SESSION['s_galleryListingSortOrder']=='author'){
 	               $templateSortBy.="<option value='author' SELECTED>Author</option>";
                }else{
                       $templateSortBy.="<option value='author'>Author</option>";
                }
        }
        $templateSortBy.="</select>&nbsp;<input type='submit' value='go' class='sortFormButton' /></form>";
	$loopvars->set_var("sort_form", $templateSortBy);

	$body_content_temp="";

	//<!-- this is where we display the actual gallery choices and page links -->
	if($galleries && ($gallerycount < (count($galleries)))){

		/* START GALLERY TILES TABLE */
		$body_content_temp.="<table width='{$primaryGalleryWidth}' class='galleryListing' cellspacing='{$galleryTilesSpacing}'>";

		$intColumnCount=1;
		for($y = $gallerycount; $y < ($gallerycount+$maxgalleriesperpage); $y++){

                	if($intColumnCount==1){
                	        $body_content_temp.="<tr>";
			}

			if($galleryListingSortOrder=="dateDESC" || $galleryListingSortOrder=="dateASC" ||
                	$galleryListingSortOrder=="dateModifiedDESC" || $galleryListingSortOrder=="dateModifiedASC" ||
			$galleryListingSortOrder=="titleAlphabetical" || $galleryListingSortOrder=="author"){
				    $v_gallery=$galleries[$y][0];
			}else{
				$V_gallery=$galleries[$y];
			}

			//get gallery details
			$galleryInfo=get_gallery_details($galleriesRoot.$v_gallery);
			$posterID=$galleryInfo[0];
			$datePosted=$galleryInfo[1];
			$title=$galleryInfo[2];
			$description=$galleryInfo[3];
			$downloadLink=$galleryInfo[5];
			$galleryCopyright=$galleryInfo[6];
			$concealPath=$galleryInfo[7];

			/* THE USER MIGHT HAVE SELECTED THEIR OWN DEFAULT SAMPLE IMAGE FOR THIS GALLERY.
			   IF THEY DID THEN CHECK FOR ITS EXISTENCE AND RETURN ITS PRESENCE. OTHERWISE LETS FIND
			   OUR OWN SAMPLE (THE FIRST IMAGE IN THE GALLERY)
			*/
			$sampleimages=array();
			$thm_set=0;
			$galleryThumbnail="";
			if (file_exists($galleriesRoot.$v_gallery."/thm.php")) {
				include $galleriesRoot.$v_gallery."/thm.php";
				if(file_exists($galleriesRoot.$v_gallery."/".$galleryThumbnail)){
					$thm_set=1;
				}
			}
			if($thm_set==0){
			        $clsDirListingSample = new clsDirListing($galleriesRoot.$v_gallery, 5);
				$clsDirListingSample->sortOrder("titleAlphabetical");
			        $clsDirListingSample->extensionIncludes(array("jpg", "gif", "png", "jpeg"));
			        $clsDirListingSample->prefixIncludes(array("thm_"));
			        $sampleimages=$clsDirListingSample->getListing();
			        $clsDirListingSample="";
			}

			//protect the core -- force themes to use the variable manager
			$loopvars->set_var("body_content", $body_content_temp);
			unset($body_content_temp);
			include $themeName."/gallerydetails.inc.php";
			$body_content_temp=$loopvars->get_var("body_content");

                        /* IF THIS IS THE END OF THE ROW THEN ITS TIME TO END THIS ROW AND FLAG FOR NEW ROW.
                           IF WERE OUT OF IMAGES THEN BREAK LOOP
                        */
                        if($intColumnCount==$numGalleryColumns){
                            $body_content_temp.="</tr>";
                            $intColumnCount=1;

			    if(($y) == (count($galleries)-1)){
				break;
			    }
                        }else{
                            //check for a break again
                            if(($y) == (count($galleries)-1)){
                                 for($colouttage=$intColumnCount; $colouttage<$numGalleryColumns; $colouttage++){
                                     $body_content_temp.="<td></td>";
                                 }
                                 $body_content_temp.="</tr>";
				 break;
                            }
                            $intColumnCount++;
                        }
		}
		$body_content_temp.="</table>";

	}else {
        	$body_content_temp.="<span class='status'><br/><br/><br/>There were no galleries that matched your search criteria!<br/><br/><br/><br/><br/></span>";
        }

	//store loop var body content
        $loopvars->set_var("body_content", $body_content_temp);
	unset($body_content_temp); 
                             
        /* THEME HEADER */
        include $themeName."/overall_header.php";
                 
        if(!$loopvars->get_var("get_head")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_head().
                     </div>");
        }

	//check for get_body() call -- for legacy support automatically spit out content if no call is made by footer.
        //This will be dropped by 4.0
        if(!$loopvars->get_var("get_content")){
                $loopvars->echo_var("body_content");
        }

	/* THEME FOOTER */
	include $themeName."/overall_footer.php";

	if(!$loopvars->get_var("get_footer")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_footer().
                     </div>");
        }

	//<!-- end gallery choices and page links-->
	break;

  default:
	if(isset($_SESSION['s_userName'])){
        	$templateCreateGallery="<a $ajaxifynewgallery href='admin/index.php?action=editgallerydetails&amp;galleryname=NEW' $target><img src='{$themeName}/images/createNewGalleryHome.gif' border=0 /></a>";
	}

	/* DISPLAY GALLERIES
	   the default action is to list all galleries (or virtual personal galleries if requested)
	*/

	if(!$gp){
		$gp=1;
	}


	/*
	Create a new directory listing instance and process directory listing for master gallery images
	*/
	if($pg!=""){
		$clsDirListingDefault = new clsDirListing($galleriesRoot, 3);
		$clsDirListingDefault->prefixIncludes(array($pg."_"));
	}else{
		$clsDirListingDefault = new clsDirListing($galleriesRoot, 2);
	}
	$clsDirListingDefault->sortOrder($galleryListingSortOrder);
	$clsDirListingDefault->excludes(array("logs"));
	$galleries=$clsDirListingDefault->getListing();
	$clsDirListingDefault="";


	$maxgalleriesperpage=$numGalleryColumns*$numGalleryRows;
        $pages=intval((count($galleries)-1) / $maxgalleriesperpage);
        if($pages < ((count($galleries)) / $maxgalleriesperpage)){
                $extrapage=1;
        } else {
                $extrapage=0;
        }
        $totalpages=$pages+$extrapage;

	$gallerycount=($gp-1)*$maxgalleriesperpage;

	/* FIGURE OUT HOW MANY PAGES WERE GOING TO NEED */
	if($gp>1){
		$prevtemp=($gallerycount-$maxgalleriesperpage);
		$linkpage=$gp-1;
                $previouspage="<a href='$pageFileName?gp={$linkpage}{$appendPG1}' $target>&lt;</a>";
	}

	if($totalpages>$gp){
		$nexttemp=($gallerycount+$maxgalleriesperpage);
		$linkpage=$gp+1;
                $nextpage="<a href='$pageFileName?gp={$linkpage}{$appendPG1}' $target>&gt;</a>";
	}

	$pages=intval((count($galleries)-1) / $maxgalleriesperpage);
	if($pages < ((count($galleries)) / $maxgalleriesperpage)){
		$extrapage=1;
	} else {
		$extrapage=0;
	}
	$totalpages=$pages+$extrapage;

        //Work out page breaks. We dont want to overload our users with every page in the gallery...
        $PREpageoutstring="";
        $POSTpageoutstring="";
        if(intval($gp) < 10){ //Were in the first 10 pages
                $startPage=1;
                $endPage=10;

                if($totalpages<$endPage){
                       $endPage=$totalpages;
                }

		if($totalpages!=$endPage){
                	$POSTpageoutstring="&nbsp;<b>...</b>&nbsp;<a href='$pageFileName?gp={$totalpages}{$appendPG1}' $target>$totalpages</a>";
		}
        }else{
                if(intval(substr($gp, strlen($gp)-1, 1))==0){ //were past the first 10 pages and its a "milestone"
                        $startPage=intval($gp)-1;
                        $endPage=intval($gp)+10;

                        if($totalpages<$endPage){
                                $endPage=$totalpages;
                                $POSTpageoutstring="";
                        }

			$PREpageoutstring="<a href='$pageFileName?gp=1{$appendPG1}' $target>1</a>&nbsp;&nbsp;<b>...</b>&nbsp;";
			if($totalpages!=$endPage){
                        	$POSTpageoutstring="&nbsp;<b>...</b>&nbsp;&nbsp;<a href='$pageFileName?gp={$totalpages}{$appendPG1}' $target>$totalpages</a>";
			}
                }else{ //were past the first 10 pages but its not a "milestone"
                        $tempPageCalc=$gp;
                        $tempPageCalc=substr_replace($gp, 0, strlen($gp)-1, 1);
                        $startPage=$tempPageCalc-1;
                        $endPage=$tempPageCalc+10;

                        if($totalpages<$endPage){
                                $endPage=$totalpages;
                                $POSTpageoutstring="";
                        }

                        $PREpageoutstring="<a href='$pageFileName?gp=1{$appendPG1}' $target>1</a>&nbsp;&nbsp;<b>...</b>&nbsp;";
			if($totalpages!=$endPage){
	                        $POSTpageoutstring="&nbsp;<b>...</b>&nbsp;&nbsp;<a href='$pageFileName?gp={$totalpages}{$appendPG1}' $target>$totalpages</a>";
			}
                }
        }

        $pageoutstringA=$PREpageoutstring;
	/* LOOP THROUGH THE PAGE COUNT AND CREATE THE OUTPUT FOR USE IN OUR THEME FOR THE PAGE LINKS.
	   wE WILL DENOTE THE CURRENT PAGE WITH BRACKETS. IF THE THEME WANTS TO DO SOMETHING DIFFERENT
	   THEY CAN REPLACE THE CHARS.
	*/
        $pageoutstringA=$PREpageoutstring;
        //compile extra page links
        for($z=$startPage; $z < $endPage+1; $z++){
		$tempcount=(($z*$maxgalleriesperpage)-$maxgalleriesperpage);

                if($z==$gp){
                    $curpagemarker1='  [&nbsp;';
                    $curpagemarker2='&nbsp;]';
                }else{
                    $curpagemarker1='';
                    $curpagemarker2='';
                }

		if($totalpages!=1)
		    $pageoutstringA.=" <a href='$pageFileName?gp={$z}{$appendPG1}' $target>$curpagemarker1$z$curpagemarker2</a>&nbsp;";
	}
	$pageoutstringA.=$POSTpageoutstring;

	$templateSortBy="<form method='post' action='index.php{$appendPG2}' enctype='multipart/form-data' class='sortForm'><input type='hidden' name='cms' value='{$cms}' /><select name='galleryListingSortOrder' class='sortForm' onChange='this.parentNode.submit();'>";
        if($_SESSION['s_galleryListingSortOrder']=='dateDESC'){
	        $templateSortBy.="<option value='dateDESC' SELECTED>Newest to Oldest</option>";
        }else{
                $templateSortBy.="<option value='dateDESC'>Newest to Oldest</option>";
        }
        if($_SESSION['s_galleryListingSortOrder']=='dateASC'){
                $templateSortBy.="<option value='dateASC' SELECTED>Oldest to Newest</option>";
        }else{
                $templateSortBy.="<option value='dateASC'>Oldest to Newest</option>";
        }
        if($_SESSION['s_galleryListingSortOrder']=='dateModifiedDESC'){
                $templateSortBy.="<option value='dateModifiedDESC' SELECTED>Recently Modified</option>";
        }else{
                $templateSortBy.="<option value='dateModifiedDESC'>Recently Modified</option>";
        }
        if($_SESSION['s_galleryListingSortOrder']=='titleAlphabetical'){
                $templateSortBy.="<option value='titleAlphabetical' SELECTED>Gallery Title</option>";
        }else{
                $templateSortBy.="<option value='titleAlphabetical'>Gallery Title</option>";
        }
        if(!$pg){
                if($_SESSION['s_galleryListingSortOrder']=='author'){
                	$templateSortBy.="<option value='author' SELECTED>Author</option>";
                }else{
                        $templateSortBy.="<option value='author'>Author</option>";
                }
        }
        $templateSortBy.="</select>&nbsp;<input type='submit' value='go' class='sortFormButton' /></form>";
	$loopvars->set_var("sort_form", $templateSortBy);

	$body_content_temp="";

	//<!-- this is where we display the actual gallery choices and page links -->
	if($galleries && ($gallerycount < (count($galleries)))){

		/* START GALLERY TILES TABLE */
		$body_content_temp.="<table width='{$primaryGalleryWidth}' class='galleryListing' cellspacing='{$galleryTilesSpacing}'>";

		$intColumnCount=1;
		for($y = $gallerycount; $y < ($gallerycount+$maxgalleriesperpage); $y++){

                	if($intColumnCount==1){
                	        $body_content_temp.="<tr>";
			}

			if($galleryListingSortOrder=="dateDESC" || $galleryListingSortOrder=="dateASC" ||
                	$galleryListingSortOrder=="dateModifiedDESC" || $galleryListingSortOrder=="dateModifiedASC" ||
			$galleryListingSortOrder=="titleAlphabetical" || $galleryListingSortOrder=="author"){
				    $v_gallery=$galleries[$y][0];
			}else{
				$V_gallery=$galleries[$y];
			}

			//get gallery details
			$galleryInfo=get_gallery_details($galleriesRoot.$v_gallery);
			$posterID=$galleryInfo[0];
			$datePosted=$galleryInfo[1];
			$title=$galleryInfo[2];
			$description=$galleryInfo[3];
			$downloadLink=$galleryInfo[5];
			$galleryCopyright=$galleryInfo[6];
			$concealPath=$galleryInfo[7];
 
			if(can_edit($v_gallery, $_SESSION['s_userName'])){
		                $templateUpload="<a title='upload images' $ajaxifyupload href='admin/index.php?action=uploadimages&amp;galleryname={$v_gallery}&cms={$cms}'><img src='{$themeName}/images/galtile_uploadImages.gif' border=0 /></a>";
		                $templateEditGallery="<a title='edit gallery properties' $ajaxifynewgallery href='admin/index.php?action=editgallerydetails&amp;galleryname={$v_gallery}&cms={$cms}'><img src='{$themeName}/images/galtile_editGallery.gif' border=0 /></a>";
				$templateDeleteGallery="<a title='delete gallery' $ajaxifydelete href='admin/index.php?action=deletegallery&amp;galleryname={$v_gallery}&cms={$cms}'><img src='{$themeName}/images/galtile_deleteGallery.gif' border=0 /></a>";
		        }else{
				$templateUpload="";
		                $templateEditGallery="";
		                $templateDeleteGallery="";
			}
			

			/* THE USER MIGHT HAVE SELECTED THEIR OWN DEFAULT SAMPLE IMAGE FOR THIS GALLERY.
			   IF THEY DID THEN CHECK FOR ITS EXISTENCE AND RETURN ITS PRESENCE. OTHERWISE LETS FIND
			   OUR OWN SAMPLE (THE FIRST IMAGE IN THE GALLERY)
			*/
			$sampleimages=array();
			$thm_set=0;
			$galleryThumbnail="";
			if (file_exists($galleriesRoot.$v_gallery."/thm.php")) {
				include $galleriesRoot.$v_gallery."/thm.php";
				if(file_exists($galleriesRoot.$v_gallery."/".$galleryThumbnail)){
					$thm_set=1;
				}
			}
			if($thm_set==0){
			        $clsDirListingSample = new clsDirListing($galleriesRoot.$v_gallery, 5);
				$clsDirListingSample->sortOrder("titleAlphabetical");
			        $clsDirListingSample->extensionIncludes(array("jpg", "gif", "png", "jpeg"));
			        $clsDirListingSample->prefixIncludes(array("thm_"));
			        $sampleimages=$clsDirListingSample->getListing();
			        $clsDirListingSample="";
			}

			//protect the core -- force themes to use the variable manager
			$loopvars->set_var("body_content", $body_content_temp);
                        unset($body_content_temp);  
                        include $themeName."/gallerydetails.inc.php";
                        $body_content_temp=$loopvars->get_var("body_content");

                        /* IF THIS IS THE END OF THE ROW THEN ITS TIME TO END THIS ROW AND FLAG FOR NEW ROW.
                           IF WERE OUT OF IMAGES THEN BREAK LOOP
                        */
                        if($intColumnCount==$numGalleryColumns){
                            $body_content_temp.="</tr>";
                            $intColumnCount=1;

			    if(($y) == (count($galleries)-1)){
				break;
			    }
                        }else{
                            //check for a break again
                            if(($y) == (count($galleries)-1)){
                                 for($colouttage=$intColumnCount; $colouttage<$numGalleryColumns; $colouttage++){
                                     $body_content_temp.="<td></td>";
                                 }
                                 $body_content_temp.="</tr>";
				 break;
                            }
                            $intColumnCount++;
                        }
		}
		$body_content_temp.="</table>";

	}else{
		$body_content_temp.="<span class='status'><br/><br/>There are no galleries.<br/>";		
		if($allowUserRegistration){
			$body_content_temp.="<br/>Click the 'new user registration' tab to register for an account.";
		}
		$body_content_temp.="<br/>Login to your account, create a gallery, and begin populating it with images!<br/><br/><br/><br/></span>";

	}

	//store loop var body content
        $loopvars->set_var("body_content", $body_content_temp);
	unset($body_content_temp); 
         
        /* THEME HEADER */
        include $themeName."/overall_header.php";
                
        if(!$loopvars->get_var("get_head")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_head().
                     </div>");
        }

	//check for get_body() call -- for legacy support automatically spit out content if no call is made by footer.
        //This will be dropped by 4.0
        if(!$loopvars->get_var("get_content")){
                $loopvars->echo_var("body_content");
        }

	/* THEME FOOTER */
	include $themeName."/overall_footer.php";
	
	if(!$loopvars->get_var("get_footer")){
                die("<div style='font-weight: bold; font-size: 1.3em; padding-top: 100px; padding-bottom: 100px;'>
                        Error: Theme must make call to the function get_footer().
                     </div>");
        }

	//<!-- end gallery choices and page links-->
	break;
}

unset($loopvars);

?>
