<?php	
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: rssgallery.xml.php                                        #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

header('Content-Type: text/xml');

	$gallery='';

	if(ISSET($_GET['g']))
		$gallery=$_GET['g'];

        $g_Directory="galleries/".$gallery."/";

	$includeFlag='1'; //only way for our included files to know their included.
                
        if(!$gp)
                $gp=1;
                
        //get the directory list, each image gallery is in its own directory
        $g_Listing = dir($g_Directory);
        while($entry = $g_Listing->read()) {
               	if( (!is_dir($g_Directory."/".$entry)) && (substr($entry, 0, 3) != 'thm') && (substr($entry, 0, 7) != 'lowres_')
                        && ((strtolower(substr($entry, (strlen($entry)-3), 3)) == 'jpg')
                        || (strtolower(substr($entry, (strlen($entry)-3), 3)) == 'gif')
                        || (strtolower(substr($entry, (strlen($entry)-3), 3)) == 'png')
                        || (strtolower(substr($entry, (strlen($entry)-3), 3)) == 'avi')
                        || (strtolower(substr($entry, (strlen($entry)-3), 3)) == 'mpg')   
                        || (strtolower(substr($entry, (strlen($entry)-4), 4)) == 'mpeg')
                        || (strtolower(substr($entry, (strlen($entry)-3), 3)) == 'mov')
                        || (strtolower(substr($entry, (strlen($entry)-3), 3)) == 'wmv') ) ) {

                    //date modified
                    $sortCriteria=filemtime($g_Directory."/".$entry);                            
                    $images[]=array($entry, $sortCriteria);
                }
            
        }
        $g_Listing->close();
        sortByDate($images, "dateModifiedDESC");

echo '<?xml version="1.0" encoding="UTF-8"?>
      <rss version="2.0">
      <channel>';

include 'config.php';

$x=0;
if(count($images) > 9){
    $x=9;
}else{
    $x=count($images);
}

if (file_exists($g_Directory."index.php")){
    include $g_Directory."index.php";
    $posterID=htmlspecialchars(strtolower(trim($galleryInfo[0])), ENT_QUOTES);
    $datePosted=htmlspecialchars($galleryInfo[1], ENT_QUOTES);
    $title=htmlspecialchars($galleryInfo[2], ENT_QUOTES);
    $description=htmlspecialchars($galleryInfo[3], ENT_QUOTES);
} else {
    $posterID="Unavailable";
    $datePosted="Unavailable";
    $title="Title Unknown";
    $description="No description given";
}

echo "<title>".$title." Image Feed</title>
      <link>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=vg&amp;g=$gallery</link>
      <description>$description</description>";

$y=0;
for ($y = 0 ; $y <= $x; $y++) {
	echo "<item>\n";
	echo "<title>".$images[$y][0]."</title>\n";
	echo "<description>".$images[$y][0]."</description>\n";
	echo "<link>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=vi&amp;g=".$gallery."&amp;i=".$images[$y][0]."</link>\n";
	echo "</item>\n";
}

echo '</channel>
      </rss>';
?>

<?php
//open files with shared locked and returns an array of file contents
function openFile($filename){
        $readsize=4096;
        
        //open file and aquire shared lock 
        $fv=fopen($filename, 'r');
        flock($fv, LOCK_SH);
         
        //initialize vars and get array of file
        $temp=array();
        $counter=0;
        while ($line=fgets($fv, $readsize)) {
          $temp[$counter] = $line;
          $counter=$counter+1;
        }
                
        //relinquish lock and close file
        flock($fv, LOCK_UN);
        fclose($fv);
        
        //return our array
	return $temp;
}       
function natcasesort2d(&$aryInput) {
//this function will sort an array without maintaining keys
  $aryOut='';
 
  $aryTemp = $aryInput;

  if(is_array($aryTemp))
     natcasesort($aryTemp);
        
  if(!empty($aryTemp)){
    foreach ($aryTemp as $value) { //natcasesort will sort our array but it also preserves key associations
      $aryOut[] = $value;           //this way we step through a create a fresh array with no associations
    }   
  }
  $aryInput = $aryOut;           //return array
}
function SortByDate(&$Files, $sortCriteria)
{       
    if($sortCriteria=="dateDESC" || $sortCriteria=="dateModifiedDESC")
        usort($Files, "numericSortDESC");
        
    if($sortCriteria=="dateASC" || $sortCriteria=="dateModifiedASC")
        usort($Files, "numericSortASC");
         
    if($sortCriteria=="titleAlphabetical" || $sortCriteria=="author")
        usort($Files, "alphabeticalSort");
}
function numericSortDESC($a, $b)
{
    return ($a[1] < $b[1]) ? 1 : 0;
}
?>
