<?php
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: sitemap.xml.php                                           #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

header('Content-Type: text/xml');
echo '<?xml version="1.0" encoding="UTF-8"?>';

if(!file_exists("./config.php")){
    die("<b>You must configure Panda Image Gallery! <br/><br/>Please review config.php.sample, configure as necessary, 
	and rename config.php.sample to config.php. <br/><br/>See the README or installation notes for installation details.</b>");
}

$galleriesRoot="galleries/";

//enable benchmarking code
$benchmark=0;
if($benchmark){
    //benchmark code
    $bench = new Timer;
    $bench->starttime();
}

include_once './config.php';
$themeName='themes/'.$themeName;
include_once $themeName.'/options.php';

	$g_Directory = $galleriesRoot;
        $g_Listing = dir($g_Directory);
        while($entry = $g_Listing->read()) {
            if ($entry != "." && $entry != ".." && $entry != "logs") {
                if(is_dir($g_Directory."/".$entry)) {
                        /* PERSONAL GALLERY CHECK */
                        if(($pg!='' && $pg==$galleryInfo[0]) || $pg==''){
                                $galleries[]=$entry;
                        }
         
                }
            }
        }
        $g_Listing->close();
                                
        $maxgalleriesperpage=$numGalleryColumns*$numGalleryRows;
        $pages=intval((count($galleries)-1) / $maxgalleriesperpage);
        if($pages < ((count($galleries)) / $maxgalleriesperpage)){
                $extrapage=1;
        } else {
                $extrapage=0;
        }
        $totalpages=$pages+$extrapage;

	echo '<urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';


        //compile directory page links
        for($x=1; $x < $totalpages+1; $x++){
		echo "<url>
			<loc>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?gp=$x</loc>
			<lastmod>".date('Y-m-d', time())."</lastmod>
			<changefreq>monthly</changefreq>
			<priority>0.8</priority>
			</url>";
        }

	echo '</urlset>';              
?>

<?php
//Benchmark code
if($benchmark){
        $total = $bench->gettime();
        echo "Total execution time: $total<br />\n";
}
                
//Thanks to Brian Stanback for this simple execution timer
class Timer {
        function getmicrotime() {
                list($usec, $sec) = explode(" ", microtime());
                return ((float)$usec + (float)$sec);
        }
        function starttime() {
                $this->st = $this->getmicrotime();
        }
        function gettime() {
                $this->et = $this->getmicrotime();
                return round(($this->et - $this->st), 5);
        }
}
?>
